#!/bin/sh

function usage () {
	cat <<EOF
Usage: $0 
EOF
	exit -2
}

[ $# -lt 0 ] && usage
[ $# -gt 0 ] && usage

WD=$(echo $0 | awk '{sub(/\/[^\/]*?$/,""); print}')
source $WD/variables.sh
UGDIR=$BUDIR/upgrade

FAIL=0;
mkdir -o $UGDIR;
for i in $BUFILES;
do
	tar -C $UGDIR -zxf $UGDIR/$i.tgz
	for j in $(tar -C $UGDIR -ztf $UGDIR/$i.tgz)
	do
		if [[ ! -e $UGDIR/$j ]]
		then
			exit -1
		fi
	done
done

exit 0

