#!/bin/sh

function usage () {
	cat <<EOF
Usage: $0 
EOF
	exit -2
}

[ $# -lt 0 ] && usage
[ $# -gt 0 ] && usage

WD=$(echo $0 | awk '{sub(/\/[^\/]*?$/,""); print}')
source $WD/variables.sh
UGDIR=$BUDIR/upgrade

FAIL=0;
for i in $BUFILES;
do
	cp -R $UGDIR/$i/* $SMICONFIG/$i/ || exit -1
done

chown -R www-data:www-data $SMICONFIG || exit -2
chmod -R g+w $SMICONFIG || exit -3

exit 0

