#!/usr/bin/awk
#################################################################
# filename : mkIfCfgEth0.awk
# purpose  : update /smi/etc/sysconfig/ifcfg-eth0 file
#            with smiCmLan.data configuration parameters
#################################################################
# usage: 
#	awk -f mkIfCfgEth0.awk smiCmLan.data
#################################################################
BEGIN	{ 
        print "#########################################################";
        print "#   ifcfg-eth0";
        print "#   modified by CM-II web server ";
        print "#########################################################";
	print "DEVICE=eth0";
	print "BOOTPROTO=static";
	print "ENABLE=yes";
}

/^ethernet_ipAddr=[ \t]*[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[ \t]*$/  && length($2) > 0 { print "IPADDR=" $2; }
/^ethernet_subnetmask=[ \t]*[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[ \t]*$/  && length($2) > 0 { print "NETMASK=" $2; }
/^ethernet_network=[ \t]*[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[ \t]*$/  && length($2) > 0 { print "NETWORK=" $2; }
/^ethernet_broadcast=[ \t]*[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[ \t]*$/  && length($2) > 0 { print "BROADCAST=" $2; }
