#!/usr/bin/awk

# usage: 
#	awk -f mkNetCfg.awk smiCmLan.data

BEGIN	{ 
	print "NETWORKING=yes";
	print "GW_DEV=eth0";
	print "DEFRAG_IPV4=no";
	print "FORWARD_IPV4=no";
}

/^ethernet_host_name/ && length($2) > 0     { print "HOSTNAME=\"" $2 "\""; }
/^ethernet_ip_addr_type/ && length($2) > 0 { print "BOOTPROTO=" $2 ; }
/^ethernet_gateway=[ \t]*[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[ \t]*$/  && length($2) > 0 { print "GATEWAY=" $2; }

