#!/bin/sh
#//////////////////////////////////////////////////////////////////
#//
#//------------------------------------------------------------
#// Copyright(c) 2008: Southwest Microwave,Inc.
#//------------------------------------------------------------
#//
#// FILENAME:
#//    createDefFiles.sh
#//
#// PURPOSE:
#//    bourne shell script to populate default files
#//
#////////////////////////////////////////////////////////////////////
#/////////////////////////////////////////////////////////////////////
#// local variables
#/////////////////////////////////////////////////////////////////////
counter=0
max=16

prefix="smiCmDev_"
suffix=".def"

defFile="smiCmDev.def"

for (( counter = 1, deviceId= 0; counter <= max; counter++, deviceId++ ))
do
    filename=($prefix$counter$suffix)

    echo "copying $defFile to $filename"
    cp $defFile $filename

done


