<?php

require_once('login.class.php');

global $subpage;
global $login;
global $message;
global $hash;

/* Security Policy
 * smiSuper and smiAdmin have full functionality
 * smiUser can not see this page
 * FIXME: Not implemented yet
 */

if(!isset($_POST['s'])) {
	$_POST['s'] = 0;
}

switch($_POST['s']) {
case 0:
break;
case 1:
/* Modify User */
	$login->setCursor($_POST['id']);

break;
case 2:
/* Add User */
	$id = $login->findEmptyUserSlot();
	if($id === FALSE) {
		$login->makeMessage('No empty user slots');
		$_POST['s'] = 0;
	}
break;
case 3:
/* Delete User */
	$login->setCursor($_POST['id']);
break;
case 4:
/* Modify User Confirmed (no display) */
	if(!$login->newPassword (
			$_POST['id'],
			addslashes(trim($_POST['name'],",\" \t\n")),
			addslashes(trim($_POST['pass'],",\" \t\n")),
			addslashes(trim($_POST['pass2'],",\" \t\n"))
		)
	) { 
		$_POST['s'] = 1; 
	} else {
		$_POST['s'] = 0; 
	}
break;
case 5:
/* Delete User Confirmed (no display) */
	$login->deleteUser($_POST['id']);
	$_POST['s'] = 0;
break;
case 6:
/* Confirm Restore Defaults */
break;
case 12:
/* Add User Confirmed (no display */
	$id = $login->findEmptyUserSlot();
	if($id === FALSE) {
		$login->makeMessage('No empty user slots');
		$_POST['s'] = 0;
		break;
	}
	if(!$login->addNewUser (
			$id,
			addslashes(trim($_POST['name'],",\" \t\n")),
			addslashes(trim($_POST['pass'],",\" \t\n")),
			addslashes(trim($_POST['pass2'],",\" \t\n"))
		)
	) {
		$_POST['s'] = 2;
	} else {
		$_POST['s'] = 0;
	}
break;
case 16:
/* Restore Defaults Confirmed */
	$login->restoreDefaults();
	$_POST['s'] = 0;
break;
default:

break;
}
?>

<? if($message->count() >= 0): ?>
        <div id="errormessage">
		<hr/>
<?= $message->dump() ?>
		<hr/>
        </div>
<? endif; ?>

<? switch($_POST['s']): ?>
<? case 0: ?>
<form class="formquit" method="POST" action="/" onSubmit="pleaseWait(); return true;">
<? break; ?>
<? default: ?>
<form class="formquit" method="POST" action="/accounts/" onSubmit="pleaseWait(); return true;">
<? break; ?>
<? endswitch; ?>
<input type="hidden" name="s" value="0" />
<input class="submitquit only" type="submit" name="submit" value="<?= /* TRANSLATOR: Button Text */ _('Quit') ?>" />
</form>

<h2><?= _('CM-II') ?> <?= 
/* TRANSLATOR: Header Text for the Account Management page, 
where user accounts can be added, deleted, and passwords changed.
*/ 
_('Account Management') 
?> <? // CAREFUL!  Switch must close the </h2> ?>
<? switch($_POST['s']): ?>
<? case 0: ?>
</h2>

<table>
<? if(strcmp($login->logintype,'admin') === 0): ?>
<tr>
<td>
<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="6" />
<input class="submitbutton" type="submit" name="change" value="<?= 
/* TRANSLATOR: Button Text. Meaning, Restore user accounts to the factory-set default state. */
_('Restore Defaults')
?>" />
</form>
</td>
</tr>
<? endif ?>
<tr>
<th><?= 
/* TRANSLATOR: Table header in Account Management page. Meaning: User Name.
*/
_('Name') 
?></th><th><?= 
/* TRANSLATOR: Table header in Account Management page.  Meaning: Type of user.
*/
_('Type') 
?></th>
</tr>
<? foreach($login->userData as $u): ?>
<? if(isset($u['name']) && strlen($u['name']) > 0): ?>
<? if($login->allowChange($u['id'])): ?>
<tr>
<td><?= $u['name'] ?></td>
<td><?= _($u['type']) ?></td>
<td><form method="POST" action="" onSubmit="pleaseWait(); return true;" style="margin: 0;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $u['id'] ?>" />
<input type="hidden" name="s" value="1" />
<input class="submitbutton" type="submit" name="change" value="<?= 
/* TRANSLATOR: Button Text. Meaning, Modify user account. */
_('Modify')
?>" />
</form></td>
</tr>
<? endif ?>
<? endif; ?>
<? endforeach; ?>
</table>
<? if(!$login->maxUsers() && $login->allowChange('','user')): ?>
<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="2" />
<input class="submitbutton" type="submit" name="add" value="<?=
/* TRANSLATOR: Button Text.  Meaning, Add a new user account. */
_('Add New User')
?>" />
</form>
<? endif; ?>
<? break; ?>

<? case 1: ?>
 - <?= /* TRANSLATOR: Header Text */ _('Modify User') ?> </h2>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $login->cursor['id'] ?>" />
<table>
<tr>
<th><?= /* TRANSLATOR: Field Entry Text */ _('Name') ?></th>
<td><input type="hidden" name="name" value="<?= $login->cursor['name'] ?>" />
<?= $login->cursor['name'] ?></td>
</tr>
<tr>
<th><?= /* TRANSLATOR: Field Entry Text */ _('Type') ?></th>
<td>
<?= $login->cursor['type'] ?>
</td>
</tr>
<? if($login->allowChange($login->cursor['id'])): ?>
<tr>
<th><?= /* TRANSLATOR: Text before a field entry */ _('New Password') ?></th>
<td><input type="password" name="pass" value="" /></td>
</tr>
<tr>
<th><?= /* TRANSLATOR: Text before a field entry */ _('Confirm Password') ?></th>
<td><input type="password" name="pass2" value="" /></td>
</tr>
<? endif ?>
</table>

<? if($login->allowChange($login->cursor['id'])): ?>
<input class="submitbutton" type="reset" name="reset" value="<?= 
/* TRANSLATOR: Button text.  Reset all fields to their prior values. */ 
_('Reset') 
?>" />
<? endif ?>
<input type="hidden" name="s" value="4" />
<? if($login->allowChange($login->cursor['id'])): ?>
<input class="submitbutton" type="submit" name="submitpw" value="<?= 
/* TRANSLATOR: Button text.  Submit a changed user's password. */
_('Submit New Password')
?>" />
<? endif ?>
</form>

<? if($login->allowDelete($login->cursor['id']) && !$login->itsMe($login->cursor['id'])): ?>
<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $login->cursor['id'] ?>" />
<input type="hidden" name="s" value="3" />
<input class="submitbutton" type="submit" name="delete" value="<?=
/* TRANSLATOR: Button Text */
_('Delete User')
?>" />
</form>
<? endif ?>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="0" />
<input class="submitbutton" type="submit" name="submit" value="<?= /* TRANSLATOR: Button Text */ _('Cancel') ?>" />
</form>

<? break; ?>

<? case 2: ?>
 - <?= /* TRANSLATOR: Header Text */ _('Add User') ?></h2>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<table>
<tr>
<th><?= _('Name') ?></th>
<td><input type="text" name="name" maxlength="32" size="32" value="<?= $login->cursor['name'] ?>" /></td>
</tr>
<tr>
<th><?= _('Type') ?></th>
<td>
user
</td>
</tr>
<tr>
<th><?= _('New Password') ?></th>
<td><input type="password" name="pass" maxlength="32" size="32" value="" /></td>
</tr>
<tr>
<th><?= _('Confirm Password') ?></th>
<td><input type="password" name="pass2" maxlength="32" size="32" value="" /></td>
</tr>
</table>

<input type="hidden" name="s" value="12" />
<input class="submitbutton" type="reset" name="reset" value="<?= _('Reset') ?>" />
<input class="submitbutton" type="submit" name="submitadd" value="<?= 
/* TRANSLATOR: Button Text */ 
_('Submit') 
?>" />
</form>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="0" />
<input class="submitbutton" type="submit" name="cancel" value="<?=
/* TRANSLATOR: Button Text.  Cancel this action and go back to the previous state. */
_('Cancel') 
?>" />
</form>

<? break; ?>

<? case 3: ?>
 - <?= /* TRANSLATOR: Header Text */ _('Delete User') ?></h2>

<div id="errormessage">
<hr/>
<p><strong><?=
/* TRANSLATOR: Message/warning text. */
sprintf(_(' Are you sure you want to delete user %s ?'),$login->cursor['name'])
?></strong></p>
<hr/>
</div>

<table>
<tr>
<th><?= _('Name') ?></th>
<td><?= $login->cursor['name'] ?></td>
</tr>
<tr>
<th><?= _('Type') ?></th>
<td>
<?= $login->cursor['type'] ?>
</td>
</tr>
</table>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="0" />
<input class="submitbutton" type="submit" name="cancel" value="<?= _('No') ?>" />
</form>
<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $login->cursor['id'] ?>" />
<input type="hidden" name="name" value="<?= $login->cursor['name'] ?>" />
<input type="hidden" name="s" value="5" />
<input class="submitbutton" type="submit" name="confdel" value="<?= _('Yes') ?>" />
</form>

<? break; ?>

<? case 6: ?>
 - <?= /* TRANSLATOR: Header Text */ _('Confirm Restore Defaults') ?></h2>

<div id="errormessage">
<hr/>
<p><strong><?=
/* TRANSLATOR: Message/warning text. */
_('Are you sure you want to restore the entire account file to the factory default setting?')
?></strong></p>
<hr/>
</div>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="0" />
<input class="submitbutton" type="submit" name="cancel" value="<?= _('No') ?>" />
</form>
<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="16" />
<input class="submitbutton" type="submit" name="confrestore" value="<?= _('Yes') ?>" />
</form>

<? break; ?>
<? endswitch; ?>

