function getCookie(c_name) {
	if (document.cookie.length>0) {
		c_start=document.cookie.indexOf(c_name + '=');
		if (c_start!=-1) { 
			c_start=c_start + c_name.length+1; 
			c_end=document.cookie.indexOf(';',c_start);
			if (c_end==-1) c_end=document.cookie.length;
			return unescape(document.cookie.substring(c_start,c_end));
		} 
	}
	return '';
}

function setCookie(c_name,value,expiredays) {
	var exdate=new Date();
	exdate.setDate(exdate.getDate()+expiredays);
	document.cookie=c_name+'='+escape(value)+((expiredays==null) ? '' : '; expires='+exdate.toGMTString()+'; path=/');
}

function eraseCookie(c_name) {
	setCookie(c_name,'',-1);
}

function openwin(url,name) {
	var popup;
	popup = window.open(url,name,'toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1');
	if(!popup.opener) {
		popup.opener = this.window;
	}
}

function poll() {
	var itsopen;
	itsopen = getCookie('itsopen');
	if(itsopen!=null && itsopen=='1') {
		document.getElementById('popupStatus').innerHTML = 'open';
		setCookie('itsopen','0',1);
	} else {
		document.getElementById('popupStatus').innerHTML = 'closed';
	}
	document.getElementById('discoverywindowname').innerHTML = window.name;
	setTimeout('poll()',2000);
}

function signal() {
	setCookie('itsopen','1',1);
	setTimeout('signal()',100);
}

