<?php

global $page;
global $subpage;
global $message;

require_once('device.class.php');

if(!isset($_POST['s'])) {
	if(isset($_GET['s'])) { 
	    $_POST['s'] = $_GET['s'];
	} else {
	    $_POST['s'] = 0; 
	}
}

if(isset($_POST['name'])) {
	$ref->noHtmlSpecial($_POST['name']);
}

$device = new Devices;

switch($_POST['s']) {

case '0':
$device->readinDevices();
$device->getCurrentStatus();
break;

case '10':
$device->readDeviceFile($_POST['id']);
$device->getCurrentStatus($_POST['id']);
break;

case '11':
$_POST['name'] = trim(substr(str_replace(array('&','"',"'",'<','>','\\',';'),"",$_POST['name']),0,64));
$getstring = 'PHPSESSID='.urlencode($_COOKIE['PHPSESSID']).'&nAddr='.urlencode($_POST['nAddr']).'&name='.urlencode($_POST['name']);
break;

case '12':
$device->changeTag(urlencode($_POST['nAddr']),urldecode($_POST['name']));
$device->readinDevices();
$device->getCurrentStatus();
$_POST['s'] = 0;
break;

case '20':
$getstring = 'PHPSESSID='.urlencode($_COOKIE['PHPSESSID']).'&nAddr='.urlencode($_POST['nAddr']);
break;

case '22':
$device->changeCsum($_POST['nAddr'],$_POST['csum']);
$message->add(
	/* TRANSLATOR: The name of a page or page header, displayed before an error message */
	DEVICE_PROFILE,
	sprintf( ACCEPTED_NEW_CONFIGURATION,$_POST['nAddr'] )
);
$device->readinDevices();
$device->getCurrentStatus();
$_POST['s'] = 0;
break;

}


?>

<? if($message->count() > 0): ?>
		<div id="errormessage">
		<hr/>
<?= $message->dump() ?>
		<hr/>
		</div>
<? endif; ?>

<?=$button->breadcrumb(false)?>

<? switch($_POST['s']): ?>
<? case '0': ?>
</h2>

<? break ?>
<? case '10': ?>
<? case '11': ?>
 &raquo; <?= /* TRANSLATOR: Header text. */ SET_DEVICE_NAME ?></h2>

<? break ?>
<? case '20': ?>
 &raquo; <?= /* TRANSLATOR: Header text. */ ACCEPT_NEW_CONFIGURATION ?></h2>

<? endswitch ?>

<p>&nbsp;</p>

<? if($_POST['s'] != 11 && $_POST['s'] != 20): ?>
<table class="disc">
<tr>
<th><?= ADDRESS ?></th>
<th><?= TYPE ?></th>
<th><?= PORT ?></th>
<th><?= STATUS ?></th>
<th><?= NAME ?></th>
<? if($_POST['s'] == 0): ?>
<th>&nbsp;</th>
<th>&nbsp;</th>
<? endif ?>
</tr>

<? endif; ?>
<? $n = 0 ?>
<? foreach($device->device as $i => $a): ?>
<? if($a->nAddr <= -1): ?>
<? continue ?>
<? endif ?>
<? $n++ ?>
<tr<?= $n%2 == 0 ? ' class="shaded"' : '' ?>>
<td><?= $a->nAddr ?></td>
<td><?= $ref->deviceString($a->ftype) ?></td>
<td><?= constant (@$ref->portIdString[$a->ttyPort]) ?></td>
<td><?= implode('<br/>',explode('|',constant(@$ref->deviceStatusString($a->devStatus)))) ?></td>
<td><?= $a->tagName ?></td>
<? switch($_POST['s']): ?>
<? case '0': ?>
<? if((hexdec($a->devStatus) & 4) == false) : /* if the device is not in com fail */ ?>
<td>
<form method="POST" action="" onSubmit="pleaseWait(); return true;" style="margin: 0;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $i ?>" />
<input type="hidden" name="nAddr" value="<?= $a->nAddr ?>" />
<input type="hidden" name="s" value="10" />
<input class="submitbutton" type="submit" name="change" value="<?= /* TRANSLATOR: Button Text */ SET_NAME ?>" />
</form>
</td>
<? if((hexdec($a->devStatus) & 2) == true) : /* if the device is compromised */ ?>
<td>
<form method="POST" action="" onSubmit="pleaseWait(); return true;" style="margin: 0;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $i ?>" />
<input type="hidden" name="nAddr" value="<?= $a->nAddr ?>" />
<input type="hidden" name="s" value="20" />
<input class="submitbutton" type="submit" name="change" value="<?= /* TRANSLATOR: Button Text */ ACCEPT_NEW_CONFIGURATION ?>" />
</form>
</td>
<? endif ?>
<? endif ?>
<? break ?>
<? case '10': ?>
</tr>
<tr>
<td colspan="7">

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $i ?>" />
<input type="hidden" name="s" value="11" />
<input type="hidden" name="nAddr" value="<?= $_POST['nAddr'] ?>" />
<p><input type="text" size="70" maxlength="64" name="name" value="<?= $a->tagName ?>" /></p>
<p><input class="submitbutton" type="submit" name="submit" value="<?= /* TRANSLATOR: Button Text */ SET_NEW_NAME ?>" /></p>
</form>

</td>
<? break ?>
<? endswitch ?>

</tr>
<? endforeach ?>
<? if($n <= 0 && $_POST['s'] != 11 && $_POST['s'] != 20): ?>
<tr><td colspan="9"><?= 
/* TRANSLATOR: Small result message.  There were no devices found, or there are no devices here now. */
NO_DEVICES
?></td></tr>
<? endif; ?>
</table>

<? switch($_POST['s']): ?>
<? case '11': ?>

<p>
<iframe frameborder="0" src="/cgi-bin/SetDeviceName?<?= $getstring ?>" name="Rename Device Page" width="530" height="220">
<?= SELECT_RENAME_DEVICE_FRAME ?>
</iframe>
</p>

<? break ?>
<? case '20': ?>
<p>
<iframe frameborder="0" src="/cgi-bin/AcceptDeviceCfg?<?= $getstring ?>" name="Accept New Device Configuration Page" width="530" height="220">
SELECT_ACCEPT_DEVICE_FRAME
</iframe>
</p>
<? endswitch ?>

