<?php

global $page;
global $message;
global $login;
global $ref;
/* Security policy:
 * smiSuper and smiAdmin have full functionality
 * smiUser has view only.
 */

$viewonly = !$login->ima(array('super','admin'));
require_once("cmlan.class.php");
$cmLan = new cmLan();

$viewingBackup = FALSE;

if(!isset($_POST['s'])) {
	$_POST['s'] = 0;
}

switch($_POST['s']) {
case 0: // start state

break;
case 1: // submit Changes or View Backup
	if(isset($_POST['viewbackup']) && file_exists($ref->smiCmLanBu)) {
		$cmLan->prepareBackupView();
		$viewingBackup = TRUE;
		$message->add(
			_('Network'),
			/* TRANSLATOR: They are now looking at a backup file */ _('Viewing Backup File')
		);
	} else {
		$cmLan->submitChanges();
		$viewingBackup = FALSE;
	}
break;
case 2: // cancel and revert
	$message->add(
		_('Network'),
		_('No changes made.  All settings reverted back to the configuration on-file.')
	);
break;
case 3: // backup
	$cmLan->backup();
break;
case 4: // restore from backup
	$cmLan->restore();
break;
}





?>
<form class="formquit" method="POST" action="/" onSubmit="pleaseWait(); return true;">
<input class="submitquit only" type="submit" name="submit" value="<?= _('Quit') ?>" />
</form>

<h2><?= _('CM-II') ?> <?= /* TRANSLATOR: Header Text.  Meaning Ethernet. */ _('Network Configuration') ?></h2>

<? if($message->count() > 0): ?>
		<div id="errormessage">
		<hr/>
<?= $message->dump() ?>
		<hr/>
		</div>
<? endif; ?>

<form action="" method="POST" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="submit" name="submit" value="<?=
/* TRANSLATOR: Button Text */
_('Submit Changes') 
?>" alt="" tabindex="0" taborder="0" 
 style="margin:0px;padding:0px;height:0px;width:0px;position:absolute;border-color:#ffffff;border-width:0px;" />
<table>
<tr>
<th><?=
/* TRANSLATOR: Network Configuration */
_('Date of Current Configuration:')
?> </th><td><?= $cmLan->smiCmLanCtime ?></td>
</tr>
<tr>
<th><?=
/* TRANSLATOR: Network Configuration */
_('Date of Backed-up Configuration:')
?> </th><td><?= $cmLan->smiCmLanBuCtime ?></td>
<? if(!$viewonly && !$viewingBackup && $cmLan->existsBackup): ?>
<td>
<input class="submitbutton" type="submit" name="viewbackup" value="<?= _('View Backup File') ?>" tabindex="0" />
</td>
<? endif; ?>
</tr>
<tr><td colspan="3"><hr></td></tr>
<? foreach($cmLan->customer_variables as $key => $val): ?>
<tr>
<th><label for="<?= $key ?>"><?= _($key) ?></label></th>
<? if(!$viewonly && !$viewingBackup): ?>
<? if(strcmp($key,"Address Type") === 0): ?>
<? /* H4X!  Direct hook in cmlan.class.php */ ?>
<td>
Static
<input type="hidden" name="<?= $key ?>" id="<?= $key ?>" value="static" />
<? /*
<select name="<?= $key ?>" id="<?= $key ?>">
<option value="static" <?= strcmp($val,'static')===0 ? 'selected="selected"' : '' ?>><?= _('Static') ?></option>
<option value="dhcp" <?= strcmp($val,'dhcp')===0 ? 'selected="selected"' : '' ?>><?= _('DHCP') ?></option>
</select>
*/ ?>
</td>
<? else: ?>
<td><input type="text" name="<?= $key ?>" id="<?= $key ?>" value="<?= $val ?>" size="20" maxlength="63" /></td>
<? endif ?>
<? else: ?>
<td><?= $val ?></td>
<? endif; ?>
<td><strong><?= $cmLan->customer_var_errors[$key] ?></strong></td>
</tr>
<? endforeach; ?>
</table>
<? if($viewingBackup): ?>
<input class="submitbutton" type="submit" name="return" value="<?=
/* TRANSLATOR: Button text.  Return to the previous screen. */
_('Return') 
?>" />
<? endif; ?>
<? if(!$viewonly && !$viewingBackup): ?>
<input type="hidden" name="s" value="1" />
<input class="submitbutton" type="reset" name="reset" value="<?= _('Reset') ?>" />
<input class="submitbutton" type="submit" name="submit" value="<?= _('Submit') ?>" />
<? endif; ?>
</form>

<? if(!$viewonly && !$viewingBackup): ?>
<form action="" method="POST" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="2" />
<input class="submitbutton" type="submit" name="revert" value="<?=
 /* TRANSLATOR: Button Text. */
_('Revert') 
?>" />
</form>

<form action="" method="POST" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="3" />
<input class="submitbutton" type="submit" name="backup" value="<?=
/* TRANSLATOR: Button Text.  Backup a file. */
_('Backup') 
?>" />
</form>
<? endif; ?>

<? if(!$viewonly): ?>
<form action="" method="POST" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="4" />
<input class="submitbutton" type="submit" name="burestore" value="<?=
/* TRANSLATOR: Button Text.  Referring to a backup file. */ 
_('Restore from Backup') 
?>" />
</form>
<? endif; ?>

