<?php

class Pmaster {

var $pm = array();

var $params = 
	Array
		(
			'version'   => array('/^[0-9]+\.[0-9]+\.[0-9]+$/',NULL,NULL,FALSE),
			'pmasterId' => array('/^[0-9]+$/',NULL,NULL,FALSE),
			'bossMode'  => array('/^[0-9]+$/',NULL,NULL,FALSE)
		);



function Pmaster() {
}



function validParam($p,$v) {
	if(!isset($this->params[$p])) {
		return(FALSE);
	}
	if((strlen($this->params[$p][0]) > 0) && (preg_match($this->params[$p][0],$v) != 1)) {
		return(FALSE);
	}
	if(($this->params[$p][3] !== FALSE) && ($v == $this->params[$p][3])) {
		return(TRUE);
	}
	if(($this->params[$p][1] !== NULL) && ($this->params[$p][2] !== NULL) && 
		($v < $this->params[$p][1] || $v > $this->params[$p][2])
	) {
		return(FALSE);
	}
	return(TRUE);
}



function readDataFile($n,$path) {

	global $ref;
	global $message;

	if($path===NULL) {
		$path = $ref->smiCmPmasterPath;
	}

	$fn = $ref->pmasterFileName($n,$path);
	$fh = fopen($fn,'r');
	if(!$fh) {
		$message->add('Pmaster',"Could not open file $fn");
		return(FALSE);
	}
	$fail = FALSE;
	while(!feof($fh)) {
		$l = trim(fgets($fh));
		if($l{0} == '#') {
			continue;
		}
		if(strlen($l) <= 0) {
			continue;
		}
		if(strpos($l,'=') === FALSE) { 
			$fail = 'no = on line '.$l; 
			break; 
		}
		list($var,$val) = @explode('=',$l);
		$var = trim($var);
		$val = trim($val,"\" \t\n");
		if(!$this->validParam($var,$val)) { 
			$fail = 'no valid parameter on line '.$l; 
			break; 
		}
		$this->pm[$n]->$var = $val;
	}
	fclose($fh);
	if($fail !== FALSE) {
		$message->add('Pmaster',"Could not parse file $fn, $fail");
		return(FALSE);
	}
	return(TRUE);
}



function readDataFiles($path=NULL) {

	global $ref;

	if($path===NULL) {
		$path = $ref->smiCmPmasterPath;
	}

	for($n=1; $n<=$ref->smiCmPmasterMax; $n++) {
		$this->readDataFile($n,$path);
	}

	return(TRUE);
}



}
