<?php

class Site {

var $siteName;

var $params = 
	Array
		(
			'version'   => array('/^[0-9]+\.[0-9]+\.[0-9]+$/',NULL,NULL,FALSE),
			'siteName'  => array('/^.{0,64}$/',NULL,NULL,FALSE),
		);




function Site() {
	$this->getSiteName();
}



function getSiteName() {
	global $ref;
	global $message;

	$cmd = 'grep siteName '.$ref->smiCmCfg.' | awk -F \'"\' \'{print $2}\'';

	$s = exec($cmd,$e,$ret);
	if($ret == 0) {
		$this->siteName = trim($s,"\"\t\n ");
		return(TRUE);
	} else {
		$message->add(SITE_INFORMATION,ERROR_GET_SITE_INFORMATION.implode("\n",$e));
		return(FALSE);
	}
}



function setSiteName($s) {
	global $ref;
	global $message;

	$s = substr(trim(str_replace( array('&','"',"'",'<','>','\\',';','/'),"",$s)),0,64);

	$cmd = 'sed -i -e \'s/siteName=.*/siteName= "'.$s.'" /\' '.$ref->smiCmCfg;
	exec($cmd,$e,$ret);
	if($ret != 0) {
		$message->add(SITE_INFORMATION,ERROR_SET_SITE_INFORMATION.implode("\n",$e));
		return(FALSE);
	}
	$this->getSiteName();
	$message->add(SITE_INFORMATION,sprintf(SITE_NAME_CHANGED,$this->siteName));
	$message->add(SITE_INFORMATION,CHANGES_WILL_APPLY);
	return(TRUE);
}



function siteName() {
	return($this->siteName);
}



function validParam($p,$v) {
	if(!isset($this->params[$p])) {
		return(FALSE);
	}
	if((strlen($this->params[$p][0]) > 0) && (preg_match($this->params[$p][0],$v) != 1)) {
		return(FALSE);
	}
	if(($this->params[$p][3] !== FALSE) && ($v == $this->params[$p][3])) {
		return(TRUE);
	}
	if(($this->params[$p][1] !== NULL) && ($this->params[$p][2] !== NULL) && 
		($v < $this->params[$p][1] || $v > $this->params[$p][2])
	) {
		return(FALSE);
	}
	return(TRUE);
}



function readDataFile($path=NULL) {
	global $ref;
	global $message;

	if($path===NULL) {
		$path = $ref->smiCmSitePath;
	}

	$fn = $path.'/'.$ref->smiCmSite;
	$fh = fopen($fn,'r');
	if(!$fh) {
		$message->add('Site',"Could not open file $fn");
		return(FALSE);
	}
	$fail = FALSE;
	while(!feof($fh)) {
		$l = trim(fgets($fh));
		if($l{0} == '#') {
			continue;
		}
		if(strlen($l) <= 0) {
			continue;
		}
		if(strpos($l,'=') === FALSE) { 
			$fail = 'no = on line '.$l; 
			break; 
		}
		list($var,$val) = @explode('=',$l);
		$var = trim($var);
		$val = trim($val,"\" \t\n");
		if(!$this->validParam($var,$val)) { 
			$fail = "no valid parameter on line $l : $var => $val"; 
			break; 
		}
		$this->$var = $val;
	}
	fclose($fh);
	if($fail !== FALSE) {
		$message->add('Site',"Could not parse file $fn, $fail");
		return(FALSE);
	}
	return(TRUE);
}



}
