<?php

require_once('login.class.php');

global $subpage;
global $login;
global $message;
global $hash;

/* Security Policy
 * smiSuper and smiAdmin have full functionality
 * smiUser can not see this page
 * FIXME: Not implemented yet
 *
 * UPDATE: most of this functionality has been left in to support
 * future upgrades/products ... CM_II has been limited to 1 admin
 * user account and no others aside from one factory admin account
 */

if(!isset($_POST['s'])) {
	$_POST['s'] = 0;
}

switch($_POST['s']) {
case 0:
break;
case 1:
/* Modify User */
	$login->setCursor($_POST['id']);

break;
case 2:
/* Add User */
	$id = $login->findEmptyUserSlot();
	if($id === FALSE) {
		$login->makeMessage('No empty user slots');
		$_POST['s'] = 0;
	}
break;
case 3:
/* Delete User */
	$login->setCursor($_POST['id']);
break;
case 4:
/* Modify User Confirmed (no display) */
	if(!$login->newPassword (
			$_POST['id'],
			addslashes(trim($_POST['name'],",\" \t\n")),
			addslashes(trim($_POST['pass'],",\" \t\n")),
			addslashes(trim($_POST['pass2'],",\" \t\n"))
		)
	) { 
		$_POST['s'] = 1; 
	} else {
		$_POST['s'] = 0; 
	}
break;
case 5:
/* Delete User Confirmed (no display) */
	$login->deleteUser($_POST['id']);
	$_POST['s'] = 0;
break;
case 6:
/* Confirm Restore Defaults */
break;
case 12:
/* Add User Confirmed (no display */
	$id = $login->findEmptyUserSlot();
	if($id === FALSE) {
		$login->makeMessage('No empty user slots');
		$_POST['s'] = 0;
		break;
	}
	if(!$login->addNewUser (
			$id,
			addslashes(trim($_POST['name'],",\" \t\n")),
			addslashes(trim($_POST['pass'],",\" \t\n")),
			addslashes(trim($_POST['pass2'],",\" \t\n"))
		)
	) {
		$_POST['s'] = 2;
	} else {
		$_POST['s'] = 0;
	}
break;
case 16:
/* Restore Defaults Confirmed */
	$login->restoreDefaults();
	$_POST['s'] = 0;
break;
default:

break;
}
?>

<? if($message->count() >= 0): ?>
        <div id="errormessage">
		<hr/>
<?= $message->dump() ?>
		<hr/>
        </div>
<? endif; ?>


<?=$button->breadcrumb(false)?>
<? // CAREFUL!  Switch must close the </h2> ?>
<? switch($_POST['s']): ?>
<? case 0: ?>
</h2>

<table>
<tr><td><br /></td></tr>
<tr>
<th><?= 
/* TRANSLATOR: Table header in Account Management page. Meaning: User Name.
*/
NAME
?></th><th><?= 
/* TRANSLATOR: Table header in Account Management page.  Meaning: Type of user.
*/
TYPE
?></th>
</tr>
<? foreach($login->userData as $u): ?>
<? if(isset($u['name']) && strlen($u['name']) > 0 && $u['name'] == 'smiAdmin'): ?>
<? if($login->allowChange($u['id'])): ?>
<tr>
<td><?= $u['name'] ?></td>
<td><?= _($u['type']) ?></td>
<td><form method="POST" action="" onSubmit="pleaseWait(); return true;" style="margin: 0;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $u['id'] ?>" />
<input type="hidden" name="s" value="1" />
<input class="submitbutton" type="submit" name="change" value="<?= 
/* TRANSLATOR: Button Text. Meaning, Modify user account. */
MODIFY
?>" />
</form></td>
</tr>
<? endif ?>
<? endif; ?>
<? endforeach; ?>

<? if(strcmp($login->logintype,'admin') === 0): ?>
<tr>
<td>
<br />
<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="6" />
<input class="submitbutton" type="submit" name="change" value="<?= 
/* TRANSLATOR: Button Text. Meaning, Restore user accounts to the factory-set default state. */
RESTORE_DEFAULTS
?>" />
</form>
</td>
</tr>
<? endif ?>

</table>
<? break; ?>

<? case 1: ?>
 &raquo; <?= /* TRANSLATOR: Header Text */ MODIFY_USER ?> </h2>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $login->cursor['id'] ?>" />
<table>
<tr>
<th><?= /* TRANSLATOR: Field Entry Text */ NAME ?></th>
<td><input type="hidden" name="name" value="<?= $login->cursor['name'] ?>" />
<?= $login->cursor['name'] ?></td>
</tr>
<tr>
<th><?= /* TRANSLATOR: Field Entry Text */ TYPE ?></th>
<td>
<?= $login->cursor['type'] ?>
</td>
</tr>
<? if($login->allowChange($login->cursor['id'])): ?>
<tr>
<th><?= /* TRANSLATOR: Text before a field entry */ NEW_PASSWORD ?></th>
<td><input type="password" name="pass" value="" /></td>
</tr>
<tr>
<th><?= /* TRANSLATOR: Text before a field entry */ CONFIRM_PASSWORD ?></th>
<td><input type="password" name="pass2" value="" /></td>
</tr>
<? endif ?>
</table>

<? if($login->allowChange($login->cursor['id'])): ?>
<input class="submitbutton" type="reset" name="reset" value="<?= 
/* TRANSLATOR: Button text.  Reset all fields to their prior values. */ 
RESET
?>" />
<? endif ?>
<input type="hidden" name="s" value="4" />
<? if($login->allowChange($login->cursor['id'])): ?>
<input class="submitbutton" type="submit" name="submitpw" value="<?= 
/* TRANSLATOR: Button text.  Submit a changed user's password. */
SUBMIT_NEW_PASSWORD
?>" />
<? endif ?>
</form>

<? if($login->allowDelete($login->cursor['id']) && !$login->itsMe($login->cursor['id'])): ?>
<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $login->cursor['id'] ?>" />
<input type="hidden" name="s" value="3" />
<input class="submitbutton" type="submit" name="delete" value="<?=
/* TRANSLATOR: Button Text */
DELETE_USER
?>" />
</form>
<? endif ?>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="0" />
<input class="submitbutton" type="submit" name="submit" value="<?= /* TRANSLATOR: Button Text */ CANCEL ?>" />
</form>

<? break; ?>

<? case 2: ?>
 &raquo; <?= /* TRANSLATOR: Header Text */ ADD_USER ?></h2>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<table>
<tr>
<th><?= NAME ?></th>
<td><input type="text" name="name" maxlength="32" size="32" value="<?= $login->cursor['name'] ?>" /></td>
</tr>
<tr>
<th><?= TYPE ?></th>
<td>
user
</td>
</tr>
<tr>
<th><?= NEW_PASSWORD ?></th>
<td><input type="password" name="pass" maxlength="32" size="32" value="" /></td>
</tr>
<tr>
<th><?= CONFIRM_PASSWORD ?></th>
<td><input type="password" name="pass2" maxlength="32" size="32" value="" /></td>
</tr>
</table>

<input type="hidden" name="s" value="12" />
<input class="submitbutton" type="reset" name="reset" value="<?= RESET ?>" />
<input class="submitbutton" type="submit" name="submitadd" value="<?= 
/* TRANSLATOR: Button Text */ 
SUBMIT
?>" />
</form>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="0" />
<input class="submitbutton" type="submit" name="cancel" value="<?=
/* TRANSLATOR: Button Text.  Cancel this action and go back to the previous state. */
CANCEL
?>" />
</form>

<? break; ?>

<? case 3: ?>
 &raquo; <?= /* TRANSLATOR: Header Text */ DELETE_USER ?></h2>

<div id="errormessage">
<hr/>
<p><strong><?=
/* TRANSLATOR: Message/warning text. */
sprintf(CONFIRM_USER_DELETE,$login->cursor['name'])
?></strong></p>
<hr/>
</div>

<table>
<tr>
<th><?= NAME ?></th>
<td><?= $login->cursor['name'] ?></td>
</tr>
<tr>
<th><?= TYPE ?></th>
<td>
<?= $login->cursor['type'] ?>
</td>
</tr>
</table>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="0" />
<input class="submitbutton" type="submit" name="cancel" value="<?= NO ?>" />
</form>
<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="id" value="<?= $login->cursor['id'] ?>" />
<input type="hidden" name="name" value="<?= $login->cursor['name'] ?>" />
<input type="hidden" name="s" value="5" />
<input class="submitbutton" type="submit" name="confdel" value="<?= YES ?>" />
</form>

<? break; ?>

<? case 6: ?>
 &raquo; <?= /* TRANSLATOR: Header Text */ CONFIRM_RESTORE_DEFAULTS ?></h2>

<div id="errormessage">
<hr/>
<p><strong><?=
/* TRANSLATOR: Message/warning text. */
CONFIRM_RESTORE_ACCOUNT
?></strong></p>
<hr/>
</div>

<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="0" />
<input class="submitbutton" type="submit" name="cancel" value="<?= NO ?>" />
</form>
<form method="POST" action="" onSubmit="pleaseWait(); return true;">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="16" />
<input class="submitbutton" type="submit" name="confrestore" value="<?= YES ?>" />
</form>

<? break; ?>
<? endswitch; ?>

