<?
	require_once('language_parser.class.php');
	require_once('locale.class.php');
	
	session_start();
	header("Content-type: text/xml"); 

// needed fix to compensate for logout
	if(empty($_SESSION['locale']))
	{
		$locale = new Locale;
		$_SESSION['locale'] = $locale;
	}		

	$p = &new language_parser($_SESSION['locale']->encoding_code);

	$result = $p->setInputFile('locale/'. $_SESSION['locale']->language_code .'/lang.xml');
	$result = $p->parse();

$header = '<?xml version="1.0" encoding="'.$_SESSION['locale']->encoding_code.'"?>';
	
?><?=$header ?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
	<?= TODAY_IS ?>: 
	<xsl:choose>
		<xsl:when test="SYSTEM_DATE/MONTH = 1">
			<?= JANUARY ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 2">
			<?= FEBRUARY ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 3">
			<?= MARCH ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 4">
			<?= APRIL ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 5">
			<?= MAY ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 6">
			<?= JUNE ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 7">
			<?= JULY ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 8">
			<?= AUGUST ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 9">
			<?= SEPTEMBER ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 10">
			<?= OCTOBER ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 11">
			<?= NOVEMBER ?>
		</xsl:when>
		<xsl:when test="SYSTEM_DATE/MONTH = 12">
			<?= DECEMBER ?>
		</xsl:when>
	</xsl:choose>
	<xsl:value-of select="SYSTEM_DATE/DAY"/>, 
	<xsl:value-of select="SYSTEM_DATE/YEAR"/>
</xsl:template>
</xsl:stylesheet>
