<?
	require_once('language_parser.class.php');
	require_once('locale.class.php');
	
	session_start();
	header("Content-type: text/xml"); 

	$p = &new language_parser($_SESSION['locale']->encoding_code);
	
	$result = $p->setInputFile('locale/'. $_SESSION['locale']->language_code .'/lang.xml');
	$result = $p->parse();

$header = '<?xml version="1.0" encoding="'.$_SESSION['locale']->encoding_code.'"?>';
	
?><?=$header ?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
<html>
<body>
	<div class="colmask threecol">
		<div class="colmid">
			<div class="colleft">
				<div class="col1">				
					<?= TOTAL_DEVICES ?> = <xsl:value-of select="TOP_BANNER/TOTAL_DEVICES"/><br/>
					<?= FAULT_TOLLERANCE ?> = <xsl:value-of select="TOP_BANNER/FAULT_TOLLERANCE"/><br/>
				</div>
				<div class="col2">
					<?= TOTAL_ZONES ?> = <xsl:value-of select="TOP_BANNER/TOTAL_ZONES"/><br/>
					<?= ZONES_ASSIGNED ?> = <xsl:value-of select="TOP_BANNER/ZONES_ASSIGNED"/><br/>
					<xsl:choose>
						<xsl:when test="TOP_BANNER/ZONES_ALARMED &gt; 0">
							<font color="red"><b>
							<?= ZONES_ALARMED ?> = <xsl:value-of select="TOP_BANNER/ZONES_ALARMED"/><br/>
							</b></font>
						</xsl:when>
						<xsl:otherwise>
							<?= ZONES_ALARMED ?> = <xsl:value-of select="TOP_BANNER/ZONES_ALARMED"/><br/>
						</xsl:otherwise>
					</xsl:choose>
				</div>
				<div class="col3">
					<xsl:choose>
						<xsl:when test="TOP_BANNER/DEVICES_IN_COMFAIL &gt; 0">
							<font color="red"><b>
							<?= DEVICES_IN_COMFAIL ?> = <xsl:value-of select="TOP_BANNER/DEVICES_IN_COMFAIL"/><br/>
							</b></font>
						</xsl:when>
						<xsl:otherwise>
							<?= DEVICES_IN_COMFAIL ?> = <xsl:value-of select="TOP_BANNER/DEVICES_IN_COMFAIL"/><br/>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:choose>
						<xsl:when test="TOP_BANNER/DEVICES_IN_SERVICE &gt; 0">
							<font color="red"><b>
							<?= DEVICES_IN_SERVICE ?> = <xsl:value-of select="TOP_BANNER/DEVICES_IN_SERVICE"/><br/>
							</b></font>
						</xsl:when>
						<xsl:otherwise>
							<?= DEVICES_IN_SERVICE ?> = <xsl:value-of select="TOP_BANNER/DEVICES_IN_SERVICE"/><br/>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:choose>
						<xsl:when test="TOP_BANNER/DEVICES_COMPROMISED &gt; 0">
							<font color="red"><b>
							<?= DEVICES_COMPROMISED ?> = <xsl:value-of select="TOP_BANNER/DEVICES_COMPROMISED"/>
							</b></font>
						</xsl:when>
						<xsl:otherwise>
							<?= DEVICES_COMPROMISED ?> = <xsl:value-of select="TOP_BANNER/DEVICES_COMPROMISED"/>
						</xsl:otherwise>
				      	</xsl:choose>
				</div>
			</div>
		</div>
	</div>
</body>
</html>
</xsl:template>
</xsl:stylesheet>
