<?php

require_once('zone.class.php');
require_once('device.class.php');

global $page;
global $subpage;
global $ref;
global $message;

if(!isset($_POST['s'])) {
    $_POST['s'] = 0; 
}

foreach($_POST as $k=>$v) {
	$_POST[$k] = trim(
		urldecode(
			preg_replace('/%[0-9a-fA-F]{1,2}/','',
				urlencode($v)
	)));
	if((strcmp($k,'zoneName') === 0) || (strcmp($k,'zoneComment') === 0)) {
		$_POST[$k] = substr($_POST[$k],0,80);
	}
}

if(isset($_GET['validzones'])) {
	$validzones = TRUE;
    $_POST['s'] = 0; 
} else {
	$validzones = FALSE;
}

$zones = new Zones;
$devices = new Devices;

$devices->readinDevices();

switch ($_POST['s']) {

case '2':

/* change zone record */

// FALLTHRU
case '1':
/* add new zone record */
//$devices->readinDevices();
$zr = $_POST['s'] == 2 ? $_POST['zr'] : -1;
if(isset($_POST['back'])) {
} else {
	$zones->readZoneFile($zr);
}

$zoneIsChanging = ($_POST['s'] == 2 ? TRUE : FALSE); 
// If we are going back, we want to fall through to case 5 (parse from POST)
if(!isset($_POST['back'])) {
	break;
}
	
case '4':
/* Confirm Add Zone Record */
/* Confirm Change Zone Record */

// FALLTHRU
case '5':
/* Return Add/Change Zone Record from CGI */

//$devices->readinDevices();

$zr = $_POST['zr'];
$zones->readZoneFile($zr);

$zones->zoneFile[$zr]->zoneInuse = 1;
$zones->zoneFile[$zr]->zoneId = $zr-1;
if(isset($_POST['state'])) {
	$zones->zoneFile[$zr]->zoneState = $_POST['state'];
	$zones->zoneFile[$zr]->state = $_POST['state'];
} else {
	$zones->zoneFile[$zr]->zoneState = isset($_POST['zoneState']) ? $_POST['zoneState'] : $ref->zoneStateDefault;
	$_POST['state'] = $zones->zoneFile[$zr]->state = $zones->zoneFile[$zr]->zoneState;
}

$zones->zoneFile[$zr]->zoneName = isset($_POST['zoneName']) ? $_POST['zoneName'] : '';
$zones->zoneFile[$zr]->zoneName = substr($zones->zoneFile[$zr]->zoneName,0,80);
$zones->zoneFile[$zr]->zoneComment = isset($_POST['zoneComment']) ? $_POST['zoneComment'] : '';
$zones->zoneFile[$zr]->zoneComment = substr($zones->zoneFile[$zr]->zoneComment,0,80);

// added to accommodate empty input/output records
$input_exists = FALSE;
$output_exists = FALSE;

foreach($_POST as $k=>$v) {
	if(strpos($k,'in') === 0) {
		$a = explode('_',$k);
		$input =& $zones->zoneFile[$zr]->input->$a[1];
		if(strpos($a[2],'nodeAddrDeviceType') !== FALSE) {
			if(strpos($v,'.') === FALSE) {
				$input['nodeAddr'] = -1;
				$input['deviceType'] = 'NA';
			} else {
				$aa = explode('.',$v);
				$input['nodeAddr'] = $aa[0];
				$input['deviceType'] = $ref->sharedMemoryToDeviceString[$aa[1]];
				
				$input_exists |= TRUE;
			}
		} elseif (strpos($a[2],'inputType') !== FALSE) {
			$input[$a[2]] = $ref->sharedMemoryToInputType[trim($v)];
			
			$input_exists |= TRUE;
		} else {
			$input[$a[2]] = trim($v) == '' ? -1 : $v;
		}
	} elseif(strpos($k,'out') === 0) {
		$a = explode('_',$k);
		$relay_out =& $zones->zoneFile[$zr]->relay_out->$a[1];
		if(strpos($a[2],'nodeAddrDeviceType') !== FALSE) {
			if(strpos($v,'.') === FALSE) {
				$relay_out['nodeAddr'] = -1;
				$relay_out['deviceType'] = 'NA';
			} else {
				$aa = explode('.',$v);
				$relay_out['nodeAddr'] = $aa[0];
				$relay_out['deviceType'] = $ref->sharedMemoryToDeviceString[$aa[1]];
				
				$output_exists |= TRUE;
			}
		} else {
			$relay_out[$a[2]] = trim($v) == '' ? -1 : $v;
		}
	}
}

// added to accommodate case without in/out-puts
if(!($input_exists & $output_exists))
{
	$_POST['state'] = 0;
	$zones->zoneFile[$zr]->zoneState = $_POST['state'];
	$zones->zoneFile[$zr]->state = $_POST['state'];
}

$zonefilevalid = TRUE;
if($_POST['s'] == 4) {
	if($zones->validateZoneFile($zr) === FALSE) {
		//$message->add(_('Zones'),_('Zone file not valid'));
		$zonefilevalid = FALSE;
		$_POST['s'] = $_POST['sp'];

		//$devices->readinDevices();
	}
}

if($_POST['s'] == 5) {
	$zones->writeZoneFile($zr,NULL,FALSE,FALSE); // to permanent file
	$zones->cleanTmpZoneFile($zr);
	unset($_SESSION['zoneStatusCache']);
	$zones->readinZones(null,null, true);
	$_POST['s'] = 0;
} else {
	$zones->writeZoneFile($zr,NULL,TRUE,FALSE); // to temporary file
}

break;

case '3':
/* Delete Zone Record */

$zr = $_POST['zr'];
$zones->readZoneFile($zr);
$zones->writeZoneFile($zr,NULL,TRUE,TRUE); // defaults to temporary file
//$devices->readinDevices();

break;

case '0':
/* Main Page of Zone Control */
//$devices->readinDevices();

default:
	$_POST['s'] = 0;

// Final step of the Create Zone and Delete Zone process
	if(isset($_POST['zr'])) {
		$zr = $_POST['zr'];
		if(isset($_POST['createsuccess']) || isset($_POST['deletesuccess'])) {
			$zones->commitZoneFile($zr);
		} else {
			$zones->cleanTmpZoneFile($zr);
		}
	}

	$zones->readinZones(NULL,$validzones,true);
	break;
} // endswitch

?>

<? if($message->count() > 0): ?>
		<div id="errormessage">
		<hr/>
<?= $message->dump() ?>
		<hr/>
		</div>
<? endif ?>

<?=$button->breadcrumb(false)?>

<? switch($_POST['s']): ?>
<? case '3': ?>
 &raquo; <?= /* TRANSLATOR: Header Text */ DELETE_ZONE_RECORD ?>
<? case '4': ?>
<? if ($_POST['s'] == 4 || $_POST['s'] == 5): ?>
 &raquo; <?= /* TRANSLATOR: Header Text */ CONFIRM_ZONE_RECORD ?>
<? endif ?>
<? case '0': ?>
<?= $validzones ? ' &raquo; '. /* TRANSLATOR: Header Text */ ZONE_REPORT : '' ?></h2>

<table class="zone" summary="<?= CURRENT_ZONE_RECORDS ?>">
	<tr>
		<td colspan="3">
<? if($_POST['s'] == 0): ?>
<? if(!$validzones): ?>
			<br /><br /><nobr>
			<form method="POST" action="" onSubmit="pleaseWait();">
				<input type="hidden" name="hash" value="<?= $hash ?>" />
				<input type="hidden" name="s" value="1" />
				<input type="hidden" name="zr" value="<?= $zones->nextBlankRecord ?>" />
				<input style="padding:0;margin:0;" class="submitbutton" type="submit" name="submit" value="<?=
				/* TRANSLATOR: Button Text */
				ADD_ZONE_RECORD 
				?>" />
			</form>
			</nobr>
			<br /><br /><hr />
			<h3>Current Zones</h3>
			
<? endif ?>
<? endif ?>
		</td>
	</tr>
<? if(!is_array($zones->zoneFile) || count($zones->zoneFile) <= 0): ?>
	<tr>
		<td><?= NO_ZONES ?></td>
	</tr>
<? else: ?>
<? foreach($zones->zoneFile as $zr => $zf): ?>
<? $zsc = $zones->zoneStateColor($zr) ?>
<? if( $zones->zoneInuse($zr) ): ?>
	<tr>
		<th class="<?= $zsc ?>" colspan="2">
			<?=
			/* TRANSLATOR: Table Header */
			ZONE_RECORD 
			?> <?= $zr <= -1 ?
sprintf( ' ** %s ** ', /* TRANSLATOR: Meaning new zone record */ NEW_STRING ) :
''
			?> &raquo; <strong><?= $zones->zoneStateString($zr) ?></strong>
		</th>
		<th class="<?= $zsc ?>" colspan="1">
<? if($_POST['s'] == 0): ?>
<? if(!$validzones): ?>
			<form method="POST" action="" onSubmit="pleaseWait();">
				<input type="hidden" name="hash" value="<?= $hash ?>" />
				<input type="hidden" name="s" value="2" />
				<input type="hidden" name="zr" value="<?= $zr ?>" />
				<input style="padding:0;margin:0 0.25em;float:right" class="submitbutton" type="submit" name="Change" value="<?=
				/* TRANSLATOR: Button Text */
				CHANGE
				?>" />
			</form>
<? endif ?>
<? if(!$validzones): ?>
			<form method="POST" action="" onSubmit="pleaseWait();">
				<input type="hidden" name="hash" value="<?= $hash ?>" />
				<input type="hidden" name="s" value="3" />
				<input type="hidden" name="zr" value="<?= $zr ?>" />
				<input style="padding:0;margin:0 0.25em;float:right" class="submitbutton" type="submit" name="Delete" value="<?=
				/* TRANSLATOR: Button Text */
				DELETE
				?>" />
			</form>
<? endif ?>
<? endif ?>
		</th>
	</tr>
	<tr>
		<td class="<?= $zsc ?>" colspan="3">
			<table>
				<tr>
					<th>
						<?=	/* TRANSLATOR: Meaning the name which a user gives a zone */ NAME ?>:
					</th>
					<td>
						<?= $zones->zoneName($zr) ?>
					</td>
				</tr>
				<tr>
					<th>
						<?=
/* TRANSLATOR: Meaning the comment which a user puts on a zone to remind the user what the zone is for */
COMMENT ?>:
					</th>
					<td>
						<?= $zones->zoneComment($zr) ?>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<th colspan="2" class="<?= $zsc ?>">
			<?= /* TRANSLATOR: Table Header */ ASSIGNED_INPUTS ?>
		</th>
		<th colspan="1" class="<?= $zsc ?>">
			<?= /* TRANSLATOR: Table Header */ ASSIGNED_OUTPUTS ?>
		</th>
	</tr>
	<tr>
		<td>
			<table>
				<tr>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning Device Address */ ADDRESS ?></th>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning which Device */ DEVICE ?></th>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning Device Name */ NAME ?></th>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning which input */ INPUT_TYPE ?></th>
					<th>&nbsp;</th>
				</tr>
<? foreach( $zf->input as $n=>$ir ): ?>
<? if(!$zones->inputIsset($zr,$n)): ?>
<? continue ?>
<? endif ?>
				<tr>
					<td><?= $zones->inputNodeAddr($zr,$n) ?></td>
					<td><?= $zones->inputDeviceType($zr,$n) ?></td>
					<td><?= $devices->device[$devices->getDeviceByNaddr($zones->inputNodeAddr($zr,$n))]->tagName ?></td>
					<td><?= constant($zones->inputTypeString($zr,$n)) ?></td>
					<td>
						<table class="zoneparms">
<? if( $zones->inputCableIdHasvalue($zr,$n) ): ?>
							<tr>
								<td style="text-align:right">
									<?=
									/* TRANSLATOR: Table Header. Indicates which cable. */
									CABLE_ID 
									?>:&nbsp;
								</td>
								<td><?= constant($zones->inputCableIdString($zr,$n)) ?></td>
							</tr>
<? endif ?>
<? if( $zones->inputStartSubcellHasvalue($zr,$n) ): ?>
							<tr>
								<td style="text-align:right">
									<?=
									/* TRANSLATOR: Table Header. Indicates which subcell to start from. */ 
									START_SUBCELL 
									?>:&nbsp;
								</td>
								<td><?= $zones->inputStartSubcell($zr,$n) ?></td>
							</tr>
<? endif ?>
<? if( $zones->inputEndSubcellHasvalue($zr,$n) ): ?>
							<tr>
								<td style="text-align:right">
									<?= 
									/* TRANSLATOR: Table Header. Indicates which subcell to end with. */ 
									END_SUBCELL 
									?>:&nbsp;
								</td>
								<td><?= $zones->inputEndSubcell($zr,$n) ?></td>
							</tr>
<? endif ?>
<? if( $zones->inputRelayNumberHasvalue($zr,$n) ): ?>
							<tr>
								<td style="text-align:right">
									<?= 
									/* TRANSLATOR: Table Header. Indicates which relay number. */ 
									INPUT_NUMBER 
									?>:&nbsp;
								</td>
								<td><?= $zones->inputRelayNumber($zr,$n) ?></td>
							</tr>
<? endif ?>
						</table>
					</td>
				</tr>
<? endforeach; // End Inputs ?> 
			</table>
		</td>
		<td class="<?= $zsc ?>">&nbsp;</td>
		<td>
			<table>
				<tr>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning Device Address */ ADDRESS ?></th>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning which Device */ DEVICE ?></th>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning Device Name */ NAME ?></th>
					<th><?= /* TRANSLATOR: Table Header. Abbreviation. Meaning which Relay */ RELAY ?></th>
				</tr>
<? foreach( $zf->relay_out as $n=>$or ): ?>
<? if(!$zones->outputIsset($zr,$n)): ?>
<? continue ?>
<? endif ?>
				<tr>
					<td><?= $zones->outputNodeAddress($zr,$n) ?></td>
					<td><?= $zones->outputDeviceTypeString($zr,$n) ?></td>
					<td><?= $devices->device[$devices->getDeviceByNaddr($zones->outputNodeAddress($zr,$n))]->tagName ?></td>
					<td><?= $zones->outputRelayNumber($zr,$n) ?></td>
				</tr>
<? endforeach; // End Outputs ?>
			</table>
		</td>
	</tr>
	<tr>
		<td class="rowbreak" colspan="3">&nbsp;</td>
	</tr>
<? endif ?>
<? endforeach;  // Zone Records ?>
<? endif ?>
</table>
<? if($_POST['s'] == 3): ?>
<form method="POST" action="/cgi-bin/DeleteZone" onSubmit="pleaseWait();">
	<input type="hidden" name="hash" value="<?= $hash ?>" />
	<input type="hidden" name="s" value="0" />
	<input type="hidden" name="zr" value="<?= $_POST['zr'] ?>" />
	<input class="submitbutton" type="submit" name="submit" value="<?=
	/* TRANSLATOR: Button Text */
	CONFIRM_DELETE
	?>" />
</form>
<form method="POST" action="" onSubmit="pleaseWait();">
	<input type="hidden" name="hash" value="<?= $hash ?>" />
	<input type="hidden" name="s" value="0" />
	<input class="submitbutton" type="submit" name="submit" value="<?= 
	/* TRANSLATOR: Button Text */
	CANCEL
	?>" />
</form>
<? endif ?>
<? if($_POST['s'] == 4): ?>
<form method="POST" action="/cgi-bin/<?= isset($_POST['Change']) ? 'EditZone' : 'CreateZone' ?>" onSubmit="pleaseWait();">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<? foreach($_POST as $name=>$value): ?>
<? if(strcmp('s',$name) === 0 || strcmp('hash',$name) === 0): ?>
<? continue ?>
<? endif ?>
<? $value = strcmp($value,'')===0 ? ' ' : $value; // H4X!! ?>
	<input type="hidden" name="<?= $name ?>" value="<?= $value ?>" />
<? endforeach ?>
<? if( isset($_POST['Change']) ): ?>
	<input type="hidden" name="Change" value="<?= CHANGE ?>" />
<? endif ?>
	<input type="hidden" name="s" value="0" />
<? if( $zonefilevalid ): ?>
	<input class="submitbutton" type="submit" name="submit" value="<?= /* TRANSLATOR: Button Text */ SAVE_ZONE ?>" />
	<? /* fix for state being 4 and startForm not present - the state switches if form does not validate */ ?>
	<script language="JavaScript" type="text/javascript"> function startForm() {} </script>
<? endif ?>
</form>
<form method="POST" action="" onSubmit="pleaseWait();">
	<input type="hidden" name="hash" value="<?= $hash ?>" />
	<input type="hidden" name="s" value="<?= isset($_POST['sp']) ? $_POST['sp'] : 2 ?>" />
	<input type="hidden" name="back" value="1" />
	<input type="hidden" name="zr" value="<?= $_POST['zr'] ?>" />

<? foreach($_POST as $name=>$value): ?>
<? if(strcmp('s',$name) === 0 || strcmp('hash',$name) === 0): ?>
<? continue ?>
<? endif ?>
<? $value = strcmp($value,'')===0 ? ' ' : $value; // H4X!! ?>
	<input type="hidden" name="<?= $name ?>" value="<?= $value ?>" />
<? endforeach ?>
<? if( isset($_POST['Change']) ): ?>
	<input type="hidden" name="Change" value="<?= CHANGE ?>" />
<? endif ?>

	
	<input class="submitbutton" type="submit" name="submit" value="<?= /* TRANSLATOR: Button Text */ BACK ?>" />
</form>
<form method="POST" action="" onSubmit="pleaseWait(); ">
	<input type="hidden" name="hash" value="<?= $hash ?>" />
	<input type="hidden" name="s" value="0" />
	<input class="submitbutton" type="submit" name="submit" value="<?= CANCEL ?>" />
</form>
<? endif ?>
<? break ?>

<? case '1': ?>
 &raquo; <?= /* TRANSLATOR: Button Text */ ADD_ZONE_RECORD ?></h2>
<? case '2': ?>
<? if ($_POST['s'] == 2): ?>
 &raquo; <?= /* TRANSLATOR: Button Text */ CHANGE_ZONE_RECORD ?></h2>
<? endif ?>

<script language="JavaScript" type="text/javascript" >
<!-- -->

var sharedMemoryToInputType = new Array();
<? foreach($ref->sharedMemoryToFtype as $smtype=>$ftype): ?>
sharedMemoryToInputType[<?= $smtype ?>] = new
	Array(
<? foreach($ref->alarmtypesForDeviceBySharedMemory[$smtype] as $k=>$at): ?>
<? end($ref->alarmtypesForDeviceBySharedMemory[$smtype]) ?>
		new Array('<?= 
// override PM Label test
constant((is_array($ref->inputTypeString[$at]) ? 
		(($smtype == 1) ?
				$ref->inputTypeString[$at][1] :
				$ref->inputTypeString[$at][0]
		) : 
		$ref->inputTypeString[$at]
))
					?>',<?= 
$ref->inputTypeToSharedMemory[$at]
					?>)<?= 
key($ref->alarmtypesForDeviceBySharedMemory[$smtype]) === $k ? '' : ',' 
					?>	
<? endforeach; ?>
	);
<? endforeach; ?>

var paramsForInputType = new Array();
<? foreach($ref->paramsForInputType as $it=>$a): ?>
paramsForInputType[<?= $ref->inputTypeToSharedMemory[$it] ?>] = new Array(
<? foreach($a as $k=>$parm): ?>
<? end($a) ?>
<?= $parm ? '1' : '0' ?><?= key($a) === $k ? '' : ',' ?> 
<? endforeach; ?>
);
<? endforeach; ?>

function addOption(it,s,v,sel) {
	var o = document.createElement('option');
	o.text = s;
	o.value = v;
	o.selected = sel;
	try
	{
		it.add(o,null); // standards compliant
	}
	catch(ex)
	{
		it.add(o); // IE only
	}
}

function makeInputTypeMenu(ind,it,sel) {
	var ftype;
	var x;
	ftype = ind.value.replace(/.*\./,"");
	for(x=0; x<sharedMemoryToInputType[ftype].length; x++) {
		addOption(it,sharedMemoryToInputType[ftype][x][0],sharedMemoryToInputType[ftype][x][1],
			(sharedMemoryToInputType[ftype][x][1]==sel ? true : false));
	}
}

function clearInputTypeMenu(it) {
	for(x in it) {
		it.remove(x);
	}
}

function updateForm() {
	var i = 0;
	var inputs_header_needed 	= new Array (false, 			false,					false,					false);
	var inputs_header 			= new Array ('cable_id_header', 'start_subcell_header', 'end_subcell_header', 	'input_relay_header');

	var maxSubcells = new Array();
	// array index is the ftype of the device, 
	// this sets the maximum subcell the user may select on the slider, -1
	maxSubcells[1] = 215; // PM_II
	maxSubcells[5] = 133; // MTP_II
	
	var maxRelays = new Array();
	// array index is the ftype of the device, 
	// this sets the number of select options
	maxRelays[1] = 4; // PM_II
	maxRelays[2] = 16; // ROM_II_16
	maxRelays[3] = 8; // ROM_II_8
	maxRelays[4] = 8; // AIM_II
	
	var output_label_needed = false;
	
	var input_label_needed = false;
	
	for(i=1; i<=<?= $zones->maxInputs ?>; i++) {
		var ind = $('in.' + i + '.nodeAddrDeviceType');
		var it  = $('in.' + i + '.inputType');
		ftype = ind.value.replace(/.*\./,"");		
		
		if(ind.value != -1) {
			var sel = it.value;
			it.disabled = false;
			it.style.backgroundColor = "#ffffff";
			it.style.visibility = "visible";

			clearInputTypeMenu(it);
			makeInputTypeMenu(ind,it,sel);

			input_label_needed = true;
						
		} else {
			it.disabled = true;
			it.style.backgroundColor = "#aaaaaa";
			it.style.visibility = "hidden";
			clearInputTypeMenu(it);
			addOption(it,'Not Assigned',0);
		}
		var inputtype = $('in.' + i + '.inputType').value;
		for(x=0; x<4; x++) {
			var parm = $('in.' + i + '.parm' + (x+1));
			if(paramsForInputType[inputtype][x]) {
				parm.disabled = false;
				parm.style.backgroundColor = "#ffffff";
				parm.style.visibility = "visible";
				
				/* can be either 2 or 3 for subcellstart or subcell end */
				if((x+1) == 2)
				{
					if((window['slider_control' + i].getRange()).end == 1)
					{						
						window['slider_control' + i].setRange($R(0,maxSubcells[ftype]));
						window['slider_control' + i].setValue(maxSubcells[ftype], 1);
						
						$('in.'+ i +'.parm2').value = 0;
						$('in.'+ i +'.parm3').value = maxSubcells[ftype];
					}
					
					$('leftSideBlack' + i).setStyle({
						width: $('leftHandle' + i).style.left
					});

					$('rightSideBlack' + i).setStyle({
						width: ($('slider'+i).clientWidth - parseInt($('rightHandle'+ i).style.left)) + 'px',
						margin: '0 0 0 ' + $('rightHandle'+ i).style.left
					});

					$('subcell_selector'+i).style.visibility = "visible";
				}
				
				// create dynamic dropdown items for AIM & PM
				if((x+1) == 4)
				{					
					try
					{
						old_val = $('in.' + i + '.parm' + (x+1) + 'PrevValue').value;
						try
						{
							old_val2 = parm.options[parm.selectedIndex].value;
						}
						catch(ex)
						{
							old_val2 = -1;
						}
						
						if(old_val2 > 0)
						{
							old_val = old_val2;
						}
						
						parm.innerHTML = ''; 
						for(counter=1; counter <= maxRelays[ftype]; counter++)
						{
							// text
							// value
							// selected
							addOption(parm,counter,counter,(old_val == counter));
						}
						
						// IE Fix
						if(old_val > 0)
						{
							// old_val for relays starts with 1 and indexing is 0 based
							parm.selectedIndex = old_val - 1;
						}
						
					} catch(ex) {}
				}
				
				inputs_header_needed[x] = true;
				
			} else {
				parm.disabled = true;
				parm.value = (x==0 ? -1 : '');
				parm.style.backgroundColor = "#aaaaaa";
				parm.style.visibility = "hidden";

				/* can be either 2 or 3 for subcellstart or subcell end */
				if((x+1) == 2)
				{
					$('subcell_selector'+i).style.visibility = "hidden";
				}

				// create dynamic dropdown items for AIM & PM
				if((x+1) == 4)
				{
					try
					{ 
						parm.innerHTML = ''; 
					} catch(ex) {}

				}				
			}
			
			if(inputs_header_needed[x] == true)
			{
				$(inputs_header[x]).style.visibility = 'visible';
			}
			else
			{
				$(inputs_header[x]).style.visibility = 'hidden';
			}
		}
	}
	if(input_label_needed == true)
	{
		$('input_header').style.visibility = 'visible';
	}
	else
	{
		$('input_header').style.visibility = 'hidden';
	}
					
	for(i=1; i<=<?= $zones->maxOutputs ?>; i++) {
		var ind = $('out.' + i + '.nodeAddrDeviceType');
		var it = $('out.' + i + '.relayOutputMask');
		var old_val = $('out.' + i + '.relayOutputMaskPrevValue').value;
		
		ftype = ind.value.replace(/.*\./,"");		
		
		if(ind.value != -1) {
			it.disabled = false;
			it.style.backgroundColor = "#ffffff";
			it.style.visibility = "visible";
						
			try
			{
				old_val2 = it.options[it.selectedIndex].value;
			}
			catch(ex)
			{
				old_val2 = -1;
			}

			if(old_val2 > 0)
			{
				old_val = old_val2;
			}
						
			it.innerHTML = ''; 
			for(counter=1; counter <= maxRelays[ftype]; counter++)
			{
				addOption(it,counter,counter,(old_val == counter));
			}
			
			// IE Fix
			if(old_val > 0)
			{
				// old_val for relays starts with 1 and indexing is 0 based
				it.selectedIndex = old_val - 1;
			}
			
			output_label_needed = true;
			
		} else {
			it.disabled = true;
			it.value = '';
			it.style.backgroundColor = "#aaaaaa";
			it.style.visibility = "hidden";
			
			clearInputTypeMenu(it);
			
			// uncomment if we want to reset the initially selected value
			
			// $('out.' + i + '.relayOutputMaskPrevValue').value = '';
		}
	}

	if(output_label_needed == true)
	{
		$('relay_header').style.visibility = 'visible';
	}
	else
	{
		$('relay_header').style.visibility = 'hidden';
	}	
}

function startForm() {
	// Could put additional code here if needed
	updateForm();
}

<!---->
</script>

<? if($zones->haveErrors()): ?>
<? $errormessage = implode("<br>\n",$zones->errors)."\n" ?>
<p>&nbsp;</p>
<div id="errormessage">
<?= $errormessage ?>
</div>
<? endif ?>

<form method="POST" action="/zonecontrol/" name="TheChangeForm" onSubmit="pleaseWait(1);">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="4" />
<input type="hidden" name="sp" value="<?= $_POST['s'] ?>" />
<input type="hidden" name="zr" value="<?= $zr ?>" />
<? if( isset($_POST['Change']) ): ?>
<input type="hidden" name="Change" value="<?= CHANGE ?>" />
<? endif ?>
<input type="hidden" name="zoneId" value="<?= $zones->zoneId($zr) ?>" />
<input type="hidden" name="zoneIsChanging" value="<?= $zoneIsChanging ? 1 : 0 ?>" />
<table class="zone" summary="<?= CURRENT_ZONE_RECORDS ?>">
<? if( $_POST['s'] != 1 ): ?>
<tr><th class="<?= $zones->zoneStateColor($zr) ?>" colspan="8"><?= /* TRANSLATOR: Table Header */ ZONE_RECORD ?> <?= $_POST['zr'] ?></th>
<? endif ?>

<tr class="mainheader">
<th colspan="7"><?= /* TRANSLATOR: Field Entry Text */ NAME ?></th>
</tr>
<tr>
<td colspan="7">
<input type="text" name="zoneName" size="80" maxlength="80" value="<?= $zones->zoneName($zr) ?>" />
</td>
</tr>
<tr class="mainheader">
<th colspan="7"><?= /* TRANSLATOR: Field Entry Text */ COMMENT ?></th>
</tr>

<tr>
<td colspan="7">
<input type="text" name="zoneComment" size="80" maxlength="80" value="<?= $zones->zoneComment($zr) ?>" />
</td>
</tr>
<tr class="mainheader">
<th colspan="7"><?= /* TRANSLATOR: Field Entry Text */ ASSIGNED_INPUTS ?></th>
</tr>
<tr>
	<th>&nbsp;</th>
	<th id="device_header"><?= /* TRANSLATOR: Table Header */ DEVICE ?></th>
	<th id="input_header"><?= /* TRANSLATOR: Table Header */ INPUT_TYPE ?></th>
	<th id="cable_id_header"><?= /* TRANSLATOR: Table Header */ CABLE_ID ?></th>
	<th id="start_subcell_header"><?= /* TRANSLATOR: Table Header */ str_replace(' ','<br>',START_SUBCELL) ?></th>
	<th id="end_subcell_header"><?= /* TRANSLATOR: Table Header */ str_replace(' ','<br>',END_SUBCELL) ?></th>
	<th id="input_relay_header"><?= /* TRANSLATOR: Table Header.  Meaning which Input Relay Number. */ str_replace(' ','<br>',INPUT_NUMBER) ?></th>
</tr>

<? for($i=1; $i<=$zones->maxInputs; $i++): ?>

<tr>
<td><?= $i ?></td>
<td>

<select name="in.<?= $i ?>.nodeAddrDeviceType" id="in.<?= $i ?>.nodeAddrDeviceType" onChange="updateForm();">
<option label="<?= NOT_ASSIGNED ?>" value="-1"><?= /* TRANSLATOR: Option list entry */ NOT_ASSIGNED ?></option>
<? $t = $zones->inputNodeAddr($zr,$i) ?>
<? foreach ($devices->device as $key => $device): ?>
<? if ($ref->isInput($device->ftype)): ?>
<? $label = $device->nAddr .' : '. $ref->deviceString[$device->ftype] .' - '. $device->tagName ?> 
<option label="<?= $label ?>" 
value="<?= $device->nAddr ?>.<?= $ref->ftypeToSharedMemory[$device->ftype] ?>"
<?= $t == $device->nAddr ? ' selected="selected" ' : '' ?>
>
<?= $label ?> 
</option>
<? endif ?>
<? endforeach ?>
</select>
</td>

<td>
<select name="in.<?= $i ?>.inputType" id="in.<?= $i ?>.inputType" onChange="updateForm();">
<? $t = $zones->inputType($zr,$i) ?>
<? foreach ($ref->inputTypeString as $id => $alarm): ?>
<?

$alarm = 	(is_array($ref->inputTypeString[$id]) ? 
				(($t == 1) ?
						$ref->inputTypeString[$id][1] :
						$ref->inputTypeString[$id][0]
				) : 
				$ref->inputTypeString[$id]
			);

?>
<? $label = "$id : ". constant($alarm) ?>
<option label="<?= $label ?>" 
value="<?= $ref->inputTypeToSharedMemory[$id] ?>"
<?= $t == $id ? ' selected="selected" ' : '' ?>
>
<?= $label ?>
</option>
<? endforeach ?>
</select>
</td>

<td>
<select name="in.<?= $i ?>.parm1" id="in.<?= $i ?>.parm1" onChange="updateForm();">
<? $t = $zones->inputCableId($zr,$i) ?>
<option label="<?= NOT_ASSIGNED ?>" value="-1"><?= NOT_ASSIGNED ?></option>
<? foreach ($ref->cableIdString as $id => $s): ?>
<option label="<?= constant($s) ?>" 
value="<?= ($id) ?>"
<?= $t == $id ? ' selected="selected" ' : '' ?>
>
<?= constant($s) ?>
</option>
<? endforeach ?>
</select>
</td>

<td colspan="2">
<input name="in.<?= $i ?>.parm2" id="in.<?= $i ?>.parm2" onChange="updateForm();" type="hidden" size="3" maxlength="3" AUTOCOMPLETE = "off"
value="<?= $zones->inputStartSubcellDisplay($zr,$i) ?>" />
<!--</td>-->
<!--<td>-->
<input name="in.<?= $i ?>.parm3" id="in.<?= $i ?>.parm3" onChange="updateForm();" type="hidden" size="3" maxlength="3" AUTOCOMPLETE = "off"
value="<?= $zones->inputEndSubcellDisplay($zr,$i) ?>" />

<style type="text/css">
  div.slider { width:250px; margin:15px 0; background-color:green; height:10px; position: relative; }
  div.leftSideBlack { width:0px; margin:0; background-color:#000; height:10px; position: absolute; }
  div.rightSideBlack { width:0px; margin: 0; background-color:#000; height:10px; position: absolute; }
  
  div.slider div.handle { z-index: 100; top: -1px; width:9px; height:13px; background-color:#f00; cursor:move; position: absolute; }
  div.handle div.handleValue { z-index: 110; top: -16px; border: solid 1px black; width: 20px; height: 12px; font-size: 0.6em; text-align: center; background-color: #ddd; position: absolute }  
  #leftHandleValue<?= $i ?> { left: -11px; }
  #rightHandleValue<?= $i ?> { left: 0px; }
</style>


<div class="subcell_selector" id="subcell_selector<?= $i ?>">
	<div class="slider" id="slider<?= $i ?>">
		<div class="leftSideBlack" id="leftSideBlack<?= $i ?>"></div>
			<div class="handle" id="leftHandle<?= $i ?>" style="background: url(/slider_l.png) no-repeat;"><div id="leftHandleValue<?= $i ?>" class="handleValue"><?= $zones->inputStartSubcellDisplay($zr , $i) ?></div></div>
			<div class="handle" id="rightHandle<?= $i ?>" style="background: url(/slider_r.png) no-repeat;"><div id="rightHandleValue<?= $i ?>" class="handleValue"><?= $zones->inputEndSubcellDisplay($zr , $i) ?></div></div>
		<div class="rightSideBlack" id="rightSideBlack<?= $i ?>"></div>
	</div>
</div>

<script type="text/javascript">

var slider_control<?= $i ?>;

  (function() {
    var slider<?= $i ?> = $('slider<?= $i ?>'),
    	leftSideBlack<?= $i ?> = $('leftSideBlack<?= $i ?>'),
    	rightSideBlack<?= $i ?> = $('rightSideBlack<?= $i ?>');
    	
    slider_control<?= $i ?> = new Control.Slider(slider<?= $i ?>.select('.handle'), slider<?= $i ?>, {
      range: $R(0, <? 
      				$dev_type = $zones->inputDeviceType($zr,$i);
					$maxSubCells =  "maxSubcells_".$dev_type;
					echo ($zones->$maxSubCells ? ($zones->$maxSubCells - 1) : "1");
					?>),
      sliderValue: [
      					<?= $zones->inputStartSubcellDisplay($zr , $i) ? $zones->inputStartSubcellDisplay($zr , $i) : "0"; ?>
      				, 
      					<?= $zones->inputEndSubcellDisplay($zr , $i) ? $zones->inputEndSubcellDisplay($zr , $i) : "1"; ?>
      				],
      restricted: true,
      
      onSlide: function(values) {
         $('leftHandleValue<?= $i ?>').innerHTML = values.map(Math.round)[0];
         $('rightHandleValue<?= $i ?>').innerHTML = values.map(Math.round)[1];
         $('in.<?= $i ?>.parm2').value = values.map(Math.round)[0];
         $('in.<?= $i ?>.parm3').value = values.map(Math.round)[1];
         
         leftSideBlack<?= $i ?>.setStyle({
			 					width: $('leftHandle<?= $i ?>').style.left
								});

         rightSideBlack<?= $i ?>.setStyle({
			 					width: ($('slider<?= $i ?>').clientWidth - parseInt($('rightHandle<?= $i ?>').style.left)) + 'px',
								margin: '0 0 0 ' + $('rightHandle<?= $i ?>').style.left
								});
      },
      onChange: function(values) { 
         $('leftHandleValue<?= $i ?>').innerHTML = values.map(Math.round)[0];
         $('rightHandleValue<?= $i ?>').innerHTML = values.map(Math.round)[1];
         $('in.<?= $i ?>.parm2').value = values.map(Math.round)[0];
         $('in.<?= $i ?>.parm3').value = values.map(Math.round)[1];
         
         leftSideBlack<?= $i ?>.setStyle({
			 					width: $('leftHandle<?= $i ?>').style.left
								});

         rightSideBlack<?= $i ?>.setStyle({
			 					width: ($('slider<?= $i ?>').clientWidth - parseInt($('rightHandle<?= $i ?>').style.left)) + 'px',
								margin: '0 0 0 ' + $('rightHandle<?= $i ?>').style.left
								});
		}
    });
  })();
</script>

<!--<input type="button" onclick="slider_control<?= $i ?>.setRange($R(0,450)); return false;" />-->

</td>

<td>
<!--<input name="in.<?= $i ?>.parm4" id="in.<?= $i ?>.parm4" onChange="updateForm();" type="text" size="3" maxlength="3" AUTOCOMPLETE = "off"
value="<?= $zones->inputRelayNumberDisplay($zr,$i) ?>" />-->
<input type="hidden" name="in.<?= $i ?>.parm4PrevValue" id="in.<?= $i ?>.parm4PrevValue" value="<?= $zones->inputRelayNumberDisplay($zr,$i) ?>" />
<select name="in.<?= $i ?>.parm4" id="in.<?= $i ?>.parm4">
</select>
</td>
</tr>

<? endfor ?>

<tr class="mainheader">
<th colspan="7"><?= /* TRANSLATOR: Table Header */ ASSIGNED_OUTPUTS ?></th>
</th>
</tr>
<tr>
	<th>&nbsp;</th>
	<th><?= DEVICE ?></th>
	<th id="relay_header"><?= RELAY ?></th>
</tr>

<? for($i=1; $i<=$zones->maxOutputs; $i++): ?>

<tr>
<td><?= $i ?></td>
<td>
<select name="out.<?= $i ?>.nodeAddrDeviceType" id="out.<?= $i ?>.nodeAddrDeviceType" onChange="updateForm();">
<? $t = $zones->outputNodeAddress($zr,$i) ?>
<option label="<?= NOT_ASSIGNED ?>" value="-1"><?= NOT_ASSIGNED ?></option>
<? foreach ($devices->device as $key => $device): ?>
<? if ($ref->isOutput($device->ftype)): ?>
<? $label = $device->nAddr .' '. $ref->deviceString[$device->ftype] .' : '. $device->tagName ?> 
<option label="<?= $label ?>"
value="<?= $device->nAddr ?>.<?= $ref->ftypeToSharedMemory[$device->ftype] ?>"
<?= $t == $device->nAddr ? ' selected="selected" ' : '' ?>
>
<?= $label ?>
</option> 
<? endif ?>
<? endforeach ?>
</select>
</td>

<td>
<!--<input name="out.<?= $i ?>.relayOutputMask" id="out.<?= $i ?>.relayOutputMask" onChange="updateForm();" type="text" size="3" maxlength="3" AUTOCOMPLETE = "off"
value="<?= $zones->outputRelayNumberDisplay($zr,$i) ?>" >-->
<input name="out.<?= $i ?>.relayOutputMaskPrevValue" id="out.<?= $i ?>.relayOutputMaskPrevValue" type="hidden" value="<?= $zones->outputRelayNumberDisplay($zr,$i) ?>" >
<select name="out.<?= $i ?>.relayOutputMask" id="out.<?= $i ?>.relayOutputMask" hint="<?= $zones->outputRelayNumberDisplay($zr,$i) ?>">

</select>
</td>
</tr>

<? endfor ?>
</tr>
</table>

<!--<input class="submitbutton" type="reset" name="reset" value="<?= RESET ?>" />-->
<input class="submitbutton" type="submit" name="submit" value="<?= SUBMIT ?>" />
</form>

<form method="POST" action="" onSubmit="pleaseWait(); ">
<input type="hidden" name="hash" value="<?= $hash ?>" />
<input type="hidden" name="s" value="0" />
<input class="submitbutton" type="submit" name="submit" value="<?= CANCEL ?>" />
</form>

<? break ?>

<? endswitch ?>

<p>&nbsp;</p>
