#!/bin/sh

function usage () {
	cat <<EOF
Usage: $0 etcDirectoryName
Examples:
	$0 /etc
	$0 /smi/etc
EOF
	exit 1
}

[ $# -lt 1 ] && usage

# PWD='/usr/local/apache2/htdocs' # when executed from apache
WD=$(echo $0 | awk '{sub(/\/[^\/]*?$/,""); print}')

awk -f $WD/mkNetworkInterfaces.awk $WD/smiCmLan.data > $1/network/interfaces
awk -f $WD/mkResolvConf.awk $WD/smiCmLan.data > $1/resolv.conf
awk -f $WD/mkHostname.awk $WD/smiCmLan.data > $1/hostname
awk -f $WD/mkNetworkOptions.awk > $1/network/options
awk -f $WD/mkNetworks.awk > $1/networks
/etc/init.d/network restart

