#!/usr/bin/awk

# usage: 
#	awk -f mkNetworkInterfaces.awk smiCmLan.data

BEGIN	{ 
	print "## Used by ifup(8) and ifdown(8). See the interfaces(5) manpage or";
	print "## /usr/share/doc/ifupdown/examples for more information.";
	print "";
	print "auto lo";
	print "iface lo inet loopback";
	print "";
	print "auto eth0";
	print "#iface eth0 inet dhcp";
	print "iface eth0 inet static";
}

/^ethernet_ipAddr=[ \t]*[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[ \t]*$/     && length($2) > 0 { print "        address   " $2; }
/^ethernet_network=[ \t]*[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[ \t]*$/    && length($2) > 0 { print "        network   " $2; }
/^ethernet_subnetmask=[ \t]*[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[ \t]*$/ && length($2) > 0 { print "        netmask   " $2; }
/^ethernet_gateway=[ \t]*[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[ \t]*$/    && length($2) > 0 { print "        gateway   " $2; }
/^ethernet_broadcast=[ \t]*[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+[ \t]*$/  && length($2) > 0 { print "        broadcast " $2; }

