#!/bin/sh

if [[ $( cat /proc/cpuinfo | grep -c 'Intel' ) -ge 1 ]]
then
# we're on a Desktop.  Short-circuit out.
	exit 0
fi

DEFAULTPROGS=''
DEFAULTPROGS="$DEFAULTPROGS     comms/mkEth0_defaults.sh"
DEFAULTPROGS="$DEFAULTPROGS   devices/restoreDefaults.sh"
DEFAULTPROGS="$DEFAULTPROGS languages/restoreDefaults.sh"
DEFAULTPROGS="$DEFAULTPROGS  pmasters/restoreDefaults.sh"
DEFAULTPROGS="$DEFAULTPROGS      site/restoreDefaults.sh"
DEFAULTPROGS="$DEFAULTPROGS     users/restoreDefaults.sh"
DEFAULTPROGS="$DEFAULTPROGS     zones/restoreDefaults.sh"

for i in $DEFAULTPROGS
do
	$i
done

