#!/bin/sh
#//////////////////////////////////////////////////////////////////
#// 
#//------------------------------------------------------------
#// Copyright(c) 2008: Southwest Microwave,Inc.
#//------------------------------------------------------------
#// 
#// FILENAME:
#//    createDefFiles.sh
#//
#// PURPOSE:
#//    bourne shell script to populate default files 
#//
#////////////////////////////////////////////////////////////////////
#/////////////////////////////////////////////////////////////////////
#// local variables
#/////////////////////////////////////////////////////////////////////
counter=0
max=256

prefix="smiCmZone_"
suffix=".def"

defFile="smiCmZone.def"


for (( counter = 1, zoneId= 0; counter <= max; counter++, zoneId++ ))
do
    filename=($prefix$counter$suffix)

    echo "copying $defFile to $filename"
    cp $defFile $filename
done

