<?php

class cmModem {



var $params = 
	Array
		(
			'version'                => array('/^[0-9]+\.[0-9]+\.[0-9]+$/',NULL,NULL,FALSE),
			'modem_port'             => array('/^[0-9]+$/',NULL,NULL,FALSE),
			'modem_port_baud'        => array('/^[0-9]+$/',NULL,NULL,FALSE),
			'modem_port_stopbits'    => array('/^[0-9]+$/',0,256,FALSE),
			'modem_port_charbits'    => array('/^[0-9]+$/',0,256,FALSE),
			'modem_port_flowcontrol' => array('/^[0-9a-zA-Z]+$/',NULL,NULL,FALSE),
			'modem_port_parity'      => array('/^[0-9a-zA-Z]+$/',NULL,NULL,FALSE),
			'modem_port_name'        => array('/^[0-9a-zA-Z\/]+$/',NULL,NULL,FALSE)
		);



function cmModem() {
}



function validParam($p,$v) {
	if(!isset($this->params[$p])) {
		return(FALSE);
	}
	if((strlen($this->params[$p][0]) > 0) && (preg_match($this->params[$p][0],$v) != 1)) {
		return(FALSE);
	}
	if(($this->params[$p][3] !== FALSE) && ($v == $this->params[$p][3])) {
		return(TRUE);
	}
	if(($this->params[$p][1] !== NULL) && ($this->params[$p][2] !== NULL) && 
		($v < $this->params[$p][1] || $v > $this->params[$p][2])
	) {
		return(FALSE);
	}
	return(TRUE);
}



function readDataFile($file) {

	global $ref;
	global $message;

	$fh = fopen($file,'r');
	if(!$fh) {
		$message->add('CmModem',"Could not open file $fn");
		return(FALSE);
	}
	$fail = FALSE;
	while(!feof($fh)) {
		$l = trim(fgets($fh));
		if($l{0} == '#') {
			continue;
		}
		if(strlen($l) <= 0) {
			continue;
		}
		if(strpos($l,'=') === FALSE) { 
			$fail = 'no = on line '.$l; 
			break; 
		}
		list($var,$val) = @explode('=',$l);
		$var = trim($var);
		$val = trim($val,"\" \t\n");
		if(!$this->validParam($var,$val)) { 
			$fail = 'no valid parameter on line '.$l; 
			break; 
		}
		$this->$var = $val;
	}
	fclose($fh);
	if($fail !== FALSE) {
		$message->add('CmModem',"Could not parse file $file, $fail");
		return(FALSE);
	}
	return(TRUE);
}




}
