<?php

require_once('menu.class.php');

global $page;
global $subpage;

/* Security Policy:
 *
 * smiSuper does not see this page.
 *
 * smiAdmin has full functionality
 * 
 * smiUser can view only.
 * 
 * FIXME: Not implemented yet.
 */

$button = new Menu(
array(
'backup',
'upgrade',
'defaults'
),
array(
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to a page where the user can
backup all configuration files in the CM-II for a complete 
restoration later in case of disaster.
*/
_('Backup'),
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to a page where the user can
upgrade or restore the CM-II to a state which the user had
backed up previously.
*/
_('Upgrade'),
/* TRANSLATOR: This string appears as a button in a menu.
Clicking on this brings the user to a page where the user can 
delete all configurations and restore them to factory defaults
*/
_('Defaults')
),
$page.'/'
);

if(strcmp($subpage,'home') == 0) {
  $button->all_normal();
} else {
  $button->select($subpage);
}

?>
<ul>

<li><?=$button->state('backup')?></li>
<li><?=$button->state('upgrade')?></li>
<li><?=$button->state('defaults')?></li>

</ul>

