<?php 
class Reference {

var $desktop = FALSE;
var $desktopfile = '/smi/desktop';

var $smiLockfile;
var $smiCmUsers = 'smiCmUsers.data'; 
var $smiCmUsersPath = '/smi/config/users'; 
var $smiCmUsersMax = 16;
var $smiCmLan = '/smi/config/comms/smiCmLan.data';
var $smiCmLanBu = '/smi/config/comms/smiCmLan.data.bak';
var $smiMkEth0 = '/smi/config/comms/mkTs7400Eth0.sh';
var $smiCmIpp2 = '/smi/config/comms/smiCmIpp2.data';
var $smiCmIpp2Bu = '/smi/config/comms/smiCmIpp2.data.bak';
var $smiCmModem = '/smi/config/comms/smiCmModem.data';
var $smiCmModemBu = '/smi/config/comms/smiCmModem.data.bak';
var $smiCmCfg = '/smi/config/site/smiCmCfg.data';
var $smiCmCfgBu = '/smi/config/site/smiCmCfg.data.bak';
var $smiCmDevPath = '/smi/config/devices';
var $smiCmDev = '%s/smiCmDev_%d.data';
var $smiCmDevDef = '%s/smiCmDev_%d.def';
var $smiCmDevMax = 16;
var $smiCmZonePath = '/smi/config/zones';
var $smiCmZone = '%s/smiCmZone_%d.%s';
var $smiCmZoneDef = '%s/smiCmZone_%d.def';
var $smiCmZoneMax = 256;
var $smiCmLangDir = '/usr/local/apache2/locale';
var $smiCmLang = '/smi/config/languages/smiCmLang.data';
var $smiCmLang_Legend = '/smi/config/languages/smiCmLang_Legend.txt';
var $smiCmPmasterPath = '/smi/pmasters';
var $smiCmPmaster = '%s/smiCmPmaster_%d.data';
var $smiCmPmasterMax = 2;
var $smiCmSitePath = '/smi/site';
var $smiCmSite = 'smiCmCfg.data';
var $smiCmLog = '/smi/log/smiCmLog.data';
var $usbmnt = '/home/alexh/workspace/cm_II/usb';

var $deviceString = 
	Array
		(
			'0x000' => 'NA',
			'0x100' => 'PM_II',
			'0x200' => 'ROM_II_16',
			'0x300' => 'ROM_II_8',
			'0x400' => 'AIM_II_8',
			'0x500' => 'MTP_II',
			'0x600' => 'MDL_330',
			'0xf00' => 'LAST',
			'0x0000' => 'NA',
			'0x0100' => 'PM_II',
			'0x0200' => 'ROM_II_16',
			'0x0300' => 'ROM_II_8',
			'0x0400' => 'AIM_II_8',
			'0x0500' => 'MTP_II',
			'0x0600' => 'MDL_330',
			'0xff00' => 'LAST'
		);

var $ftypeToSharedMemory = 
	Array
		(
			'0x000'  => 0,
			'0x100'  => 1,
			'0x200'  => 2,
			'0x300'  => 3,
			'0x400'  => 4,
			'0x500'  => 5,
			'0x600'  => 6,
			'0x0000' => 0,
			'0x0100' => 1,
			'0x0200' => 2,
			'0x0300' => 3,
			'0x0400' => 4,
			'0x0500' => 5,
			'0x0600' => 6
		);
var $sharedMemoryToFtype = array();
var $sharedMemoryToDeviceString = array();
var $deviceStringToSharedMemory = array();

var $alarmtypesForDeviceBySharedMemory = 
	Array
		(
			'-1' => array('NA'),
			'0' => array('NA'),
			'1' => array('NA','TA','CF','CP','SC','SF','IF','SV'),
			'2' => array('NA','TA','CF','CP'),
			'3' => array('NA','TA','CF','CP'),
			'4' => array('NA','TA','CF','CP','IA','IF'),
			'5' => array('NA','TA','CF','CP','SC','SF','SV'),
			'6' => array('NA','TA','CF','CP', 'MM', 'MP', 'MA')
		);
	
var $inputTypeToSharedMemory = 
	Array 
		(
			'NA' => 0,
			'SC' => 1,
			'IA' => 2,
			'IF' => 3,
			'SF' => 4,
			'TA' => 5,
			'CF' => 6,
			'CP' => 7,
			'SV' => 8,
			'MM' => 9,
			'MP' => 10,
			'MA' => 11
		);
var $sharedMemoryToInputType = Array();

var $paramsForInputType = 
	Array
		(
			'NA' => array( FALSE, FALSE, FALSE, FALSE ),
			'SC' => array( TRUE,  TRUE,  TRUE,  FALSE ),
			'IA' => array( FALSE, FALSE, FALSE, TRUE  ),
			'IF' => array( FALSE, FALSE, FALSE, TRUE  ),
			'SF' => array( TRUE,  FALSE, FALSE, FALSE ),
			'TA' => array( FALSE, FALSE, FALSE, FALSE ),
			'CF' => array( FALSE, FALSE, FALSE, FALSE ),
			'CP' => array( FALSE, FALSE, FALSE, FALSE ),
			'SV' => array( FALSE, FALSE, FALSE, FALSE ),
			'MM' => array( FALSE, FALSE, FALSE, FALSE ),
			'MP' => array( FALSE, FALSE, FALSE, FALSE ),
			'MA' => array( FALSE, FALSE, FALSE, FALSE )
		);

var $addForInputType = 
	Array
		(
			'NA' => FALSE,
			'SC' => FALSE,
			'IA' => TRUE,
			'IF' => TRUE,
			'SF' => FALSE,
			'TA' => TRUE,
			'CF' => TRUE,
			'CP' => TRUE,
			'SV' => TRUE,
			'MM' => FALSE,
			'MP' => FALSE,
			'MA' => FALSE
		);
/*
			'NA' => _('Not Assigned'),
			'SC' => _('Cable Alarm'),
			'IA' => _('Aux Input'),
			'IF' => _('Line Fault'),
			'SF' => _('Cable Fault'),
			'TA' => _('Enclosure Tamper'),
			'CF' => _('Communication Failure'),
			'CP' => _('Device Configuration Change'),
			'SV' => _('Service')		
*/		

var $inputDevices =
	Array
		(
			'0x0100',
			'0x0200',
			'0x0300',
			'0x0400',
			'0x0500',
			'0x0600'
			
		);

var $outputDevices =
	Array
		(
			'0x0200',
			'0x0300'
		);

var $deviceStatusString = Array();

var $cableIds = 
	Array
		(
			0,
			1
		);

var $portIdString = Array();

var $pollStateString = Array();

//TODO: convert into an actual bit mapping system 
//		rather than pre-encoding all states
var $sharedMemoryToZoneState = 
	Array
		(
			0  => 'UNASSIGNED',
			1  => 'ACCESS',
			2  => 'ASSIGNED',
			4  => 'ALARM',
			5  => 'ACCESS_ALARM',
			6  => 'ASSIGNED_ALARM',
			8  => 'DISABLED_UNASSIGNED',
			9  => 'DISABLED_ACCESS',
			10 => 'DISABLED_ASSIGNED',
			12 => 'DISABLED_ALARM',
			13 => 'DISABLED_ALARM_ACCESS',
			14 => 'DISABLED_ALARM_ASSIGNED'
		);
var $zoneStateToSharedMemory = Array();
var $zoneStatesForUser = 
	Array
		(
			/*0 => 0,*/ // CURRENTLY WE DISALLOW
			/*1 => 1,*/ // 0 = Unassigned && 1 = Access
			2 => 2
		);
var $zoneStateDefault = 2;

function Reference() {

	$this->inputTypeString = 
		Array 
			(
				'NA' => NOT_ASSIGNED,
				'SC' => CABLE_ALARM,
				'IA' => ALARM_INPUT,
				'IF' => array(	// SPECIAL CASE WHERE DIFFERENT DEVICES HAVE DIFFERENT STRINGS FOR SAME INPUT TYPE
								'0' => LINE_FAULT,
								'1' => EXTERNAL_INPUT
							),
				'SF' => CABLE_FAULT,
				'TA' => ENCLOSURE_TAMPER,
				'CF' => COMMUNICATION_FAILURE,
				'CP' => DEVICE_CONFIGURATION_CHANGE,
				'SV' => SERVICE,
				'MM' => MICROWAVE_330_MICRO_ALARM,
				'MP' => MICROWAVE_330_PATH_ALARM,
				'MA' => MICROWAVE_330_AUX_ALARM
			);
	
	$this->deviceStatusString = 
		Array
			(
				0x0000 => UNKNOWN,
				0x0001 => OKAY,
				0x0002 => COMPROMISED,
				0x0004 => COM_FAIL,
				0x0008 => SERVICE,
				0x0010 => ALARM
			);
	
	$this->portIdString =
		Array
			(
				0 => PORT_A,
				1 => PORT_B
			);

	$this->cableIdString = 
		Array
			(
				0 => CABLE_A,
				1 => CABLE_B
			);
	
	$this->pollStateString = 
		Array
			(
				0 => DISABLED,
				1 => ENABLED
			);

	if(file_exists($this->desktopfile)) {
		$this->desktop = TRUE;
	}

	$this->configFiles = 
		Array
			(
				&$this->smiCmUsers,
				&$this->smiCmLan,
				&$this->smiMkEth0,
				&$this->smiCmIpp2,
				&$this->smiCmModem,
				&$this->smiCmCfg,
				&$this->smiCmLang
			);

	$this->SMIDIR                =  '/smi';
	$this->USBDIR                =  '/mnt/usbdisk';
	$this->WWWDIR                =  '/usr/local/apache2/htdocs';
	$this->CGIDIR                =  '/usr/local/apache2/cgi-bin';
	$this->smiBackupSpaceNeeded  =  '262144'; // 256M
	$this->CFGDIR				 =  $this->SMIDIR.'/config';
	$this->BKUPDIR               =  $this->SMIDIR.'/backup';
	$this->UGDIR                 =  $this->BKUPDIR.'/upgrade';
	$this->TMPDIR                =  $this->BKUPDIR.'/tmp';
	$this->DEVDIR                =  $this->CFGDIR.'/devices';
	$this->DISCDIR               =  $this->SMIDIR.'/discovery';

	$this->smiLockfile           =  $this->WWWDIR.'/lock';
	$this->smiBackupUtil         =  $this->BKUPDIR.'/backupConfig.sh';
	$this->smiBackupFileRoot     =  'CMII.smi';
	$this->smiBackupFile         =  $this->BKUPDIR.'/'.$this->smiBackupFileRoot;
	$this->smiCmdGenerateBU      =  $this->smiBackupUtil.' '.$this->smiBackupFile;
	$this->smiBackupLink         =  $this->WWWDIR.'/CMII.smi';
	$this->smiBackupHref         =  '/'.$this->smiBackupFileRoot;
	$this->smiBackupUSB          =  $this->USBDIR.'/'.$this->smiBackupFileRoot;
	$this->smiCmdChkUSBConn      =  'sudo '.$this->BKUPDIR.'/usbMount.sh'; 
	$this->smiCmdUSBDisconn      =  'sudo umount '.$this->USBDIR .'/';
	$this->smiCmdChkUSBAvail     =  $this->BKUPDIR.'/usbCheck.sh '.$this->smiBackupFile;
	$this->smiCmdBackupPC        =  'rm -f '.$this->smiBackupLink.' && ln -s '.$this->smiBackupFile.' '.$this->smiBackupLink;
	$this->smiCmdBackupUSB       =  'sudo cp '.$this->smiBackupFile.' '.$this->smiBackupUSB;
	$this->smiCmdCleanBackup     =  'for i in $(ls '.$this->UGDIR.'/); do ';
	$this->smiCmdCleanBackup     .= 'for j in $(ls '.$this->UGDIR.'/$i); do ';
	$this->smiCmdCleanBackup     .= 'rm -rf '.$this->UGDIR.'/$i/$j; done; done; ';
	$this->smiCmdCleanBackup     .= 'rm -rf '.$this->UGDIR.'; ';
	$this->smiCmdCleanBackup     .= 'rm '.$this->smiBackupFile.'; ';
	$this->smiCmdCleanBackup     .= 'for i in $(ls '.$this->TMPDIR.'/); do ';
	$this->smiCmdCleanBackup     .= 'for j in $(ls '.$this->TMPDIR.'/$i); do ';
	$this->smiCmdCleanBackup     .= 'rm -rf '.$this->TMPDIR.'/$i/$j; done; done; ';
	$this->smiCmdCleanBackup     .= 'rm -rf '.$this->TMPDIR.'; ';
	$this->smiCmdFindBUfile      =  'if [[ -f '.$this->smiBackupUSB.' ]]; then exit 0; else exit -1; fi';
	$this->smiCmdChkFlashMem     =  'if [[ $( df | grep '.$this->USBDIR.' | awk \'{print $4}\' )';
	$this->smiCmdChkFlashMem     .= ' -ge $( ls -l '.$this->smiBackupUSB.' | awk \'{print $5}\' ) ]];';
	$this->smiCmdChkFlashMem     .= ' then exit 0; else exit -1; fi' ;
	$this->smiCmdMkdirBU         =  'mkdir -p '.$this->UGDIR.'; ';
	$this->smiCmdMkdirBU         .= 'if [[ $(mkdir '.$this->UGDIR.') -le -1 ]]; then exit -1; else exit 0; fi';
	$this->smiCmdUntarBU         =  'if [[ $(tar -C '.$this->UGDIR.' -zxf '.$this->smiBackupUSB.') -le -1 ]]; ';
	$this->smiCmdUntarBU         .= 'then exit -1; else exit 0; fi';
	$this->smiUpgradeVerifyUtil  =  $this->BKUPDIR.'/upgradeVerify.sh';
	$this->smiUpgradeFullUnpack  =  $this->BKUPDIR.'/upgradeFullUnpack.sh';
	$this->smiUpgradeFullCopy   =  'sudo '.$this->BKUPDIR.'/upgradeFullCopy.sh';
	$this->smiCmdUserRestore     =  $this->CFGDIR.'/users/restoreDefaults.sh';
	$this->smiCmdRestoreDef      =  $this->BKUPDIR.'/restoreDefaults.sh';
	$this->currDevices           =  $this->DISCDIR.'/currDevices.txt';
	$this->newDevices            =  $this->DISCDIR.'/newDevices.txt';
	$this->smiNewZones           =  $this->DISCDIR.'/newZones.txt';
	$this->smiRDlanguages        =  $this->CFGDIR.'/languages/restoreDefaults.sh';
	$this->smiRDpmasters         =  $this->CFGDIR.'/pmasters/restoreDefaults.sh';
	$this->smiRDsite             =  $this->CFGDIR.'/site/restoreDefaults.sh';
	$this->smiRDusers            =  $this->CFGDIR.'/users/restoreDefaults.sh';
	$this->smiRDdevices          =  $this->CFGDIR.'/devices/restoreDefaults.sh';
	$this->smiRDzones            =  $this->CFGDIR.'/zones/restoreDefaults.sh';
	$this->smiRDcomms            =  $this->CFGDIR.'/comms/restoreDefaults.sh';
	$this->smiReboot             =  'sudo reboot';

	$this->sharedMemoryToFtype = array_flip($this->ftypeToSharedMemory);
	foreach($this->sharedMemoryToFtype as $s=>$f) {
		$this->sharedMemoryToDeviceString[$s] = $this->deviceString[$f];
	}
	$this->deviceStringToSharedMemory = array_flip($this->sharedMemoryToDeviceString);
	$this->sharedMemoryToInputType = array_flip($this->inputTypeToSharedMemory);
	$this->zoneStateToSharedMemory = array_flip($this->sharedMemoryToZoneState);
	foreach ($this->zoneStatesForUser as $k=>$v) {
		$this->zoneStatesForUser[$k] =& $this->sharedMemoryToZoneState[$k];
	}

	return;
}

/*
 * Takes an ambiguous type hex value $h and outputs a device String, 
 * or empty string if there is no string.
 */
function deviceString($h) {
	$n = hexdec($h);
	if($n == 0) { return(''); }
	$hs = sprintf('0x%04x',$n); 
	if($hs == '0xffff') { return(''); }
	return(
		isset($this->deviceString[$hs]) 
			? $this->deviceString[$hs] 
			: ''
	);
}

function deviceValue($s) {
	return(array_search($s,$this->deviceString()));
}

function isInput($i) {
	return(in_array($i,$this->inputDevices));
}

function isOutput($i) {
	return(in_array($i,$this->outputDevices));
}

function deviceFileName($n,$path=NULL) {
	$path = $path === NULL ? $this->smiCmDevPath : $path;
	return(sprintf($this->smiCmDev,$path,$n));
}

function deviceFileNameDef($n,$path=NULL) {
	$path = $path === NULL ? $this->smiCmDevPath : $path;
	return(sprintf($this->smiCmDevDef,$path,$n));
}

function deviceFileNameTmp($n,$path=NULL) {
	return($this->deviceFileName($n,$path=NULL).'.tmp');
}

function zoneFileName($n,$path=NULL) {
	$path = $path === NULL ? $this->smiCmZonePath : $path;
	$e = $n <= -1 ? 'def' : 'data';
	$n = $n <= -1 ? -$n : $n;
	return(sprintf($this->smiCmZone,$path,$n,$e));
}

function zoneFileNameDef($n,$path=NULL) {
	$path = $path === NULL ? $this->smiCmZonePath : $path;
	return(sprintf($this->smiCmZoneDef,$path,$n));
}

function zoneFileNameTmpCreate($path=NULL) {
	$path = $path === NULL ? $this->smiCmZonePath : $path;
	return(sprintf($this->smiCmZone,$path,999999,'data').'.tmpCreate');
}

function pmasterFileName($n,$path=NULL) {
	$path = $path === NULL ? $this->smiCmPmaster : $path;
	return(sprintf($this->smiCmPmaster,$path,$n));
}

function deviceStatusString($h) {
	
	//fix to remove every device showing OK if really in different state
	if($h > 1)
		$h = $h - 1;

	$n = hexdec($h);
	
	$rs = '';
	foreach($this->deviceStatusString as $b => $s) {
		if($n & $b || $n == $b) {
			$rs = (strlen($rs) <= 0 ? $s : $rs.' | '.$s);
		}
	}
	return($rs);
}

function smiCmdChkUSBAvail() {
	return(sprintf($this->smiCmdChkUSBAvail,$this->smiBackupSpaceNeeded));
}

function smiCmdWriteDev($path) {
	return(sprintf($this->smiCmdWriteDev,$path));
}

function noHtmlSpecial(&$s) {
	$s = str_replace( array('&','"',"'",'<','>','\\',';'),"",$s );
	$s = str_replace( "  "," ",$s );
	return($s);
}


}
?>
